function get_automation_scripts()
	local pwd = get_session_state("pwd") -- inserting pwd, boo!
	local f = {}

	local function smith_items_craft(a, b)
		return post_page("/craft.php", { mode = "smith", pwd = pwd, action = "craft", a = get_itemid(a), b = get_itemid(b), qty = 1, ajax = 1 })
	end

	local function feed_slimeling()
		local function feed(name)
-- 			print("feeding", name)
			return post_page("/familiarbinger.php", { action = "binge", pwd = pwd, qty = 1, whichitem = get_itemid(name) })
		end
		local feed_items = get_ascension_automation_settings().slimeling_feed_items
		local feed_except_one = get_ascension_automation_settings().slimeling_feed_except_one
		for _, i in pairs(feed_items) do
			if have(i) then
				feed(i)
			end
		end
		for _, tbl in pairs(feed_except_one) do
			local found = false
			for _, i in pairs(tbl) do
				if count(i) > 1 then
					if count(i) > 10 then
						error("More than 10 of " .. i .. " when feeding slimeling")
					end
					feed(i)
				end
--~ 				if found and have(i) then
--~ 					feed(i)
--~ 				elseif have(i) then
--~ 					found = true
--~ 					if count(i) > 1 then
--~ 						feed(i)
--~ 					end
--~ 				end
			end
		end
	end

	local familiar_data = {
		["Slimeling"] = { id = 112, f = feed_slimeling, mpregen = true },
		["Mini-Hipster"] = { id = 136, mpregen = true, familiarequip = "fixed-gear bicycle" },
		["Rogue Program"] = { id = 135, mpregen = true },
		["Jumpsuited Hound Dog"] = { id = 69 },
		["Frumious Bandersnatch"] = { id = 105 },
		["Rock Lobster"] = { id = 114, mpregen = true },
		["Knob Goblin Organ Grinder"] = { id = 139 },
		["Midget Clownfish"] = { id = 106, mpregen = true },
		["Stocking Mimic"] = { id = 120, mpregen = true, familiarequip = "bag of many confections" },
		["Hobo Monkey"] = { id = 89 },
		["He-Boulder"] = { id = 113, mpregen = true },
		["Reassembled Blackbird"] = { id = 59 },
		["Baby Bugged Bugbear"] = { id = 124, familiarequip = "bugged balaclava" },
		["Llama Lama"] = { id = 90 },
		["Exotic Parrot"] = { id = 72 },
		["Mad Hatrack with spangly sombrero"] = { id = 82, familiarequip = "spangly sombrero" },
		["Pair of Stomping Boots"] = { id = 150 },
		["Jumpsuited Hound Dog for +combat"] = { id = 69 },
		["Slimeling for real"] = { id = 112, f = feed_slimeling, mpregen = true },
	}

	function f.set_familiar(famname)
		if have("spangly sombrero") and (famname == "Slimeling" or famname == "Jumpsuited Hound Dog") then
			famname = "Mad Hatrack with spangly sombrero"
		end
		local d = familiar_data[famname]
		if d then
			if d.id ~= familiarid() then
				unequip_slot("familiarequip")
				switch_familiarid(d.id)
			end
			if d.f then
				d.f()
			end
			if familiar_data[famname].familiarequip and not have(familiar_data[famname].familiarequip) then
				if not have("fixed-gear bicycle") and have("ironic moustache") then
					unequip_slot("familiarequip")
					use_item("ironic moustache")
					use_item("chiptune guitar")
					if not have("fixed-gear bicycle") then
						error "Failed to turn moustache into bicycle"
					end
				end
				if familiar_data[famname].familiarequip == "bugged balaclava" then
					get_page("/arena.php")
					if have("bugged beanie") then
						use_item("bugged beanie")
					end
					if not have(familiar_data[famname].familiarequip) then
						error "Failed to get bugged balaclava"
					end
				end
			end
			return { mpregen = familiar_data[famname].mpregen, familiarequip = familiar_data[famname].familiarequip and have(familiar_data[famname].familiarequip) and familiar_data[famname].familiarequip }
		else
			error("Unknown familiar: " .. famname)
		end
	end

	local fam = f.set_familiar

	function f.burn_mp(downto, hundreds)
		if not hundreds then
			hundreds = 50
		end
		if not downto then
			error "No downto for burn_mp"
		end
		local distance = 30
		if level() >= 8 then
			distance = 50
		end
		distance = distance + maxmp() / 5
-- 		print("burn_mp", maxmp(), (maxmp() - mp()), mp(), downto)
		if maxmp() > 50 and (maxmp() - mp()) < distance and mp() > downto and hundreds < 1000 then
			local toburn = mp() - downto
-- 			print("burn mp", toburn, hundreds, "level", level())
			if buff("Salamanderenity") and buffturns("Salamanderenity") < hundreds and toburn >= 5 then
				cast_buff(65, math.floor(toburn / 5)) -- salamander
			elseif level() < 7 and (buffturns("The Magical Mojomuscular Melody") < 50 or toburn < 10) then
				cast_buff(6004, math.floor(toburn / 5)) -- madrigal
				cast_buff(6007, math.floor(toburn / 5)) -- mojo
			elseif buffturns("Leash of Linguini") < hundreds and toburn >= 12 then
				cast_buff(3010, math.floor(toburn / 12)) -- leash of linguini
			elseif buffturns("Empathy") < hundreds and toburn >= 15 and challenge ~= "fist" then
				cast_buff(2009, math.floor(toburn / 15)) -- empathy of the newt
			elseif level() >= 6 and buffturns("Fat Leon's Phat Loot Lyric") < hundreds and toburn >= 11 then
				cast_buff(6010, math.floor(toburn / 11)) -- phat loot
			elseif level() >= 8 and level() < 13 and buffturns("Ur-Kel's Aria of Annoyance") < hundreds and toburn >= 30 then
				cast_buff(6017, math.floor(toburn / 30)) -- aria
			elseif buffturns("Springy Fusilli") < hundreds and toburn >= 10 then
				cast_buff(3015, math.floor(toburn / 10)) -- springy fusilli
			elseif buffturns("Ghostly Shell") < hundreds and toburn >= 6 and challenge ~= "fist" then
				cast_buff(2007, math.floor(toburn / 6)) -- ghostly shell
			elseif buffturns("Astral Shell") < hundreds and toburn >= 10 and challenge ~= "fist" then
				cast_buff(2012, math.floor(toburn / 10)) -- astral shell
			elseif level() >= 8 and buffturns("A Few Extra Pounds") < hundreds and toburn >= 10 then
				cast_buff(1024, math.floor(toburn / 10)) -- holiday weight gain
			else
				return f.burn_mp(downto, hundreds + 100)
			end
-- 		else
-- 			print("skipping mp burn")
		end
	end

	function f.trade_for_clover()
		if challenge == "fist" then return end
		if not have("hermit permit") then
			inform "buying hermit permit"
			buy_item("hermit permit", "m")
			if not have("hermit permit") then
				error "Failed to buy hermit permit"
			end
		end
		f.ensure_worthless_item()
		local hermitpt = get_page("/hermit.php")
		if hermitpt:contains("left in stock") then
			inform "trading for clover"
			result, resulturl = post_page("/hermit.php", { action = "trade", whichitem = get_itemid("ten-leaf clover"), quantity = 1 })
			if count("ten-leaf clover") == 0 then
				error "Failed to trade for ten-leaf clover"
			end
-- 			closet_itemid(get_itemid("ten-leaf clover"))
			use_item("ten-leaf clover")
			if count("ten-leaf clover") > 0 then
				error "Failed to hide ten-leaf clover"
			end
			did_action = true
		end
		return did_action
	end

	function f.use_and_sell_items()
		local use_items = get_ascension_automation_settings().use_items

		-- TODO: don't use wallets on fist path
		for _, w in pairs(use_items) do
			if have(w) then
				if count(w) >= 10 then
					error("Got 10+ of " .. w)
				end
				use_item(w)
			end
		end

		if challenge ~= "fist" then
			local sell_items = get_ascension_automation_settings().sell_items
			local sell_except_one = get_ascension_automation_settings().sell_except_one
			for _, s in pairs(sell_items) do
				if have(s) then
					if count(s) >= 10 then
						error("Got 10+ of " .. s)
					end
					sell_itemid(get_itemid(s), "1")
				end
			end
			for _, s in pairs(sell_except_one) do
				if count(s) >= 2 then
					if count(s) >= 10 then
						error("Got 10+ of " .. s)
					end
					sell_itemid(get_itemid(s), "1")
				end
			end
		end
	end

	function f.ensure_mp(amount)
		if maxmp() < amount then
			error("Maxmp < " .. amount .. " when trying to ensure MP")
		end
		if mp() < amount then
			local need = amount - mp()
			if need > 100 then
				error "trying to restore more than 100 mp"
			end
			local restore_items = {
				["natural fennel soda"] = 120,
				["carbonated soy milk"] = 80,
				["bottle of Monsieur Bubble"] = 60,
				["carbonated water lily"] = 65,
				["Knob Goblin superseltzer"] = 30,
				["sugar shard"] = 10,
				["ancient Magi-Wipes"] = 55,
				["phonics down"] = 50,
				["honey-dipped locust"] = 35,
				["magical mystery juice"] = 1.5 * level() + 6,
				["tonic water"] = 45,
				["black cherry soda"] = 11,
				["Knob Goblin seltzer"] = 12,
				["tiny house"] = 24,
			}
			for name, limit in pairs(restore_items) do
				if have(name) and (mp() + limit < maxmp()) then
					use_item(name)
					return f.ensure_mp(amount)
				end
			end
			for name, limit in pairs(restore_items) do
				if have(name) and (mp() + limit * 0.75 < maxmp()) then
					use_item(name)
					return f.ensure_mp(amount)
				end
			end
			for name, limit in pairs(restore_items) do
				if have(name) and (mp() + limit * 0.5 < maxmp()) then
					use_item(name)
					return f.ensure_mp(amount)
				end
			end
			if get_mainstat() == "Mysticality" and level() >= 4 and challenge ~= "fist" then
				buy_item("magical mystery juice", "2")
				if have("magical mystery juice") then
					return f.ensure_mp(amount)
				else
					error "couldn't buy mmj as lvl 4+ myst class"
				end
			elseif classid() == 6 and level() >= 9 and challenge ~= "fist" then
				buy_item("magical mystery juice", "2")
				if have("magical mystery juice") then
					return f.ensure_mp(amount)
				else
					error "couldn't buy mmj as lvl 9+ AT"
				end
			elseif have("Cobb's Knob lab key") and ((have("Knob Goblin elite helm") and have("Knob Goblin elite polearm") and have("Knob Goblin elite pants")) or level() >= 8) and challenge ~= "fist" then
				buy_item("Knob Goblin seltzer", "k", 5)
				if have("Knob Goblin seltzer") then
					return f.ensure_mp(amount)
				else
					error "Couldn't buy kgs"
				end
			elseif challenge == "fist" then
				error "Out of MP in fist"
			elseif level() >= 8 then
				error "trying to use galaktik to restore mp at level 8+"
			elseif need > 50 then
				error "trying to use galaktik to restore more than 50 MP"
			else
				post_page("/galaktik.php", { action = "curemp", pwd = pwd, quantity = need })
				if mp() < amount then
					error("Failed to reach " .. amount .. " MP using galaktik")
				end
			end
		end
	end

	local ensure_mp = f.ensure_mp

	function f.heal_up()
		if hp() / maxhp() < 0.8 and ((maxhp() - hp() >= 30) or maxhp() < 50) then
			ensure_mp(12)
			local oldhp = hp()
			cast_buff(5011) -- disco power nap
			if hp() > oldhp then
-- 				print("restore hp", oldhp, "to", hp(), "max is", maxhp())
				f.heal_up()
			else
				error "Casting Disco Power Nap didn't increase HP!"
			end
		end
	end

	function f.ensure_buffs(xs, ok_to_fail)
		local buffs = {
			["Go Get 'Em, Tiger!"] = function()
				buy_item("Ben-Gal&trade; Balm", "m", 5)
				return use_item("Ben-Gal&trade; Balm", 5)
			end,
			["Glittering Eyelashes"] = function()
				buy_item("glittery mascara", "m", 5)
				return use_item("glittery mascara", 5)
			end,
			["Butt-Rock Hair"] = function()
				buy_item("hair spray", "m", 5)
				return use_item("hair spray", 5)
			end,
			["Heavy Petting"] = function()
				if not have("Knob Goblin pet-buffing spray") then
					buy_item("Knob Goblin pet-buffing spray", "k", 1)
				end
				return use_item("Knob Goblin pet-buffing spray")
			end,
			["Peeled Eyeballs"] = function()
				if not have("Knob Goblin eyedrops") then
					buy_item("Knob Goblin eyedrops", "k", 1)
				end
				return use_item("Knob Goblin eyedrops")
			end,
			["Sugar Rush"] = function()
				local pt, pturl = cast_buff(53) -- summon crimbo candy
				local candies = { "Angry Farmer candy", "Crimbo fudge", "Crimbo peppermint bark", "Crimbo candied pecan" }
				for _, x in pairs(candies) do
					if have(x) then
						return use_item(x)
					end
				end
				return pt, pturl
			end,
			["Brother Flying Burrito's Blessing"] = function()
				return post_page("/friars.php", { pwd = pwd, action = "buffs", bro = "1" })
			end,
			["Mental A-cue-ity"] = function()
				return get_page("/clan_viplounge.php", { preaction = "poolgame", stance = "2" })
			end,
		}
		if level() < 6 then
			table.insert(xs, "The Moxious Madrigal")
			table.insert(xs, "The Magical Mojomuscular Melody")
		end
		if get_mainstat() == "Mysticality" and level() >= 6 then
			table.insert(xs, "A Few Extra Pounds")
		end
		if level() >= 6 then
			table.insert(xs, "Leash of Linguini")
			table.insert(xs, "Empathy")
		end
		if ((get_mainstat() == "Mysticality" and level() >= 9) or (level() >= 11)) and level() < 13 and challenge ~= "fist" then
			table.insert(xs, "Ur-Kel's Aria of Annoyance")
		end
		local spells = {
			["Salamanderenity"] = { spellid = 65, mpcost = 5 },
			["Earthen Fist"] = { spellid = 72, mpcost = 11 },
			["Musk of the Moose"] = { spellid = 1019, mpcost = 10 },
			["A Few Extra Pounds"] = { spellid = 1024, mpcost = 10 },
			["Ghostly Shell"] = { spellid = 2007, mpcost = 6, item = "totem" },
			["Empathy"] = { spellid = 2009, mpcost = 15, item = "totem" },
			["Astral Shell"] = { spellid = 2012, mpcost = 10, item = "totem" },
			["Curiosity of Br'er Tarrypin"] = { spellid = 2026, mpcost = 10, item = "totem" },
			["Leash of Linguini"] = { spellid = 3010, mpcost = 12 },
			["Springy Fusilli"] = { spellid = 3015, mpcost = 10 },
			["Spirit of Peppermint"] = { spellid = 3102, mpcost = 10 },
			["Spirit of Garlic"] = { spellid = 3103, mpcost = 10 },
			["Spirit of Bacon Grease"] = { spellid = 3105, mpcost = 10 },
			["Jalape&ntilde;o Saucesphere"] = { spellid = 4008, mpcost = 5, item = "saucepan" },
			["Jaba&ntilde;ero Saucesphere"] = { spellid = 4011, mpcost = 10, item = "saucepan" },
			["Smooth Movements"] = { spellid = 5017, mpcost = 10 },
			["The Moxious Madrigal"] = { spellid = 6004, mpcost = 2, effectid = 61 },
			["Polka of Plenty"] = { spellid = 6006, mpcost = 7, effectid = 63 },
			["The Magical Mojomuscular Melody"] = { spellid = 6007, mpcost = 3, effectid = 64 },
			["Fat Leon's Phat Loot Lyric"] = { spellid = 6010, mpcost = 11, effectid = 67 },
			["Ode to Booze"] = { spellid = 6014, mpcost = 50, effectid = 71 },
			["The Sonata of Sneakiness"] = { spellid = 6015, mpcost = 20, effectid = 162, shrug_first = "Carlweather's Cantata of Confrontation" },
			["Carlweather's Cantata of Confrontation"] = { spellid = 6016, mpcost = 20, effectid = 163, shrug_first = "The Sonata of Sneakiness" },
			["Ur-Kel's Aria of Annoyance"] = { spellid = 6017, mpcost = 30, effectid = 164 },
		}
		if challenge == "fist" then
			local function tabledel(t)
				for x, y in pairs(t) do
					if (spells[y] and spells[y].item) or y == "Heavy Petting" or y == "Peeled Eyeballs" or y == "A Few Extra Pounds" or y == "Butt-Rock Hair" then
						table.remove(t, x)
						return tabledel(t)
					end
				end
				return t
			end
			xs = tabledel(xs)
			if fist_level >= 3 then
				table.insert(xs, "Salamanderenity")
			end
		end
		local function shrug_buff(buffname)
			if buff(buffname) then
				print("shrugging buff", buffname, effectid)
				get_page("/charsheet.php", { pwd = pwd, ajax = 1, action = "unbuff", whichbuff = spells[buffname].effectid })
				if buff(buffname) then
					error("Failed to shrug buff: " .. buffname)
				end
			end
		end
		for name, data in pairs(spells) do
			buffs[name] = function()
				print("casting buff", name)
				ensure_mp(data.mpcost)
				if data.shrug_first then
					shrug_buff(data.shrug_first)
				end
				return cast_buff(data.spellid)
			end 
		end
		local want_buffs = {}
		for _, x in pairs(xs) do
			want_buffs[x] = true
		end
		local at_shruggable = {
			"Ode to Booze",
			"Polka of Plenty",
			"Carlweather's Cantata of Confrontation",
			"The Sonata of Sneakiness",
			"The Moxious Madrigal",
			"The Magical Mojomuscular Melody",
			"Fat Leon's Phat Loot Lyric",
		}
		if level() >= 13 and buff("Ur-Kel's Aria of Annoyance") and not want_buffs["Ur-Kel's Aria of Annoyance"] then
			shrug_buff("Ur-Kel's Aria of Annoyance")
			set_mcd(0) -- HACK: don't do this here!
		end
-- 		if buff("Ode to Booze") and not want_buffs["Ode to Booze"] then
-- 			shrug_buff("Ode to Booze")
-- 		end
		local function try_casting_buff(buffname, try_shrugging)
			if buffs[buffname] then
				local pt, pturl = buffs[buffname]()
				if not buff(buffname) then
					if pt:contains("too many songs stuck in your head") and try_shrugging then
						for _, atname in pairs(at_shruggable) do
							if buff(atname) and not want_buffs[atname] then
								shrug_buff(atname)
								return try_casting_buff(buffname, false)
							end
						end
						error("too many AT songs to cast buff: " .. buffname)
					elseif not ok_to_fail then
						error("failed to ensure buff: " .. buffname)
					end
				end
				return pt, pturl
			else
				error("trying to ensure unknown buff: " .. buffname)
			end
		end
		local ignore_buffs = get_ascension_automation_settings().ignore_buffs
		for _, x in pairs(xs) do
			if not buff(x) and not ignore_buffs[x] then
				local pt, pturl = try_casting_buff(x, true)
				if not buff(x) and not ok_to_fail then
					result, resulturl = pt, pturl
					return result, resulturl
				end
			end
		end
	end

	local ensure_buffs = f.ensure_buffs
	local function maybe_ensure_buffs(xs)
		ensure_buffs(xs, true)
	end

	function f.wear(tbl)
		local settingstbl = get_ascension_automation_settings()
		local defaults, canwear_itemname = settingstbl.default_equipment, settingstbl.canwear_itemname
		defaults.acc1 = defaults.accessories
		defaults.acc2 = defaults.accessories
		defaults.acc3 = defaults.accessories
		local neweq = {}

		local already_worn = {}

		for a, b in pairs(tbl) do
			if b ~= "empty" then
				neweq[a] = get_itemid(b)
				already_worn[b] = true
			end
		end

		local wear_slots = { "hat", "shirt", "weapon", "offhand", "pants", "acc1", "acc2", "acc3" }
		for _, a in ipairs(wear_slots) do
			if not tbl[a] and not neweq[a] then
				for _, x in pairs(defaults[a] or {}) do
					local itemname = canwear_itemname(x)
					if itemname and not already_worn[itemname] then
						neweq[a] = get_itemid(itemname)
						already_worn[itemname] = true
						break
					end
				end
			end
		end
-- 		print("setting equipment: ", table_to_str(neweq))
		set_equipment(neweq)
	end

	local wear = f.wear

	function f.check_sr()
		local tbl = ascension["fortune cookie numbers"] or {}
		for a,b in pairs(tbl) do
			if turnsthisrun() == tonumber(b) then
				inform "checking for SR"

				local lastsemi = ascension["last semirare encounter"]
				local lastturn = ascension["last semirare turn"]

				local possible = true
				if lastturn then
					if lastturn + 159 > turnsthisrun() then
						possible = false
					end
				elseif turnsthisrun() < 69 then
					possible = false
				end
				if possible then
					if lastturn and lastturn + 250 < turnsthisrun() then
						error "Last semirare was a long time ago"
					end
					print("pick up SR, last semi", lastsemi, lastturn)
					if not lastsemi and not lastturn then
						if challenge == "fist" then
							error "Fist SR, pick up wines???"
						end
						inform "Pick up first SR, make it lunchbox"
						result, resulturl, advagain = autoadventure(114)
						if result:contains("Lunchboxing") then
							use_item("Knob Goblin lunchbox")
							did_action = true
						end
						return result, resulturl, did_action
					elseif lastsemi == "Lunchboxing" then
						inform "Pick up SR, make it wines"
						result, resulturl, advagain = autoadventure(112)
						if result:contains("In the Still of the Alley") then
							inform "eating fortune cookie"
							buy_item("fortune cookie", "m")
							local old_full = fullness()
							result, resulturl = eat_item("fortune cookie")
							if fullness() == old_full + 1 then
								did_action = true
							end
						end
						return result, resulturl, did_action
					elseif lastsemi == "In the Still of the Alley" then
						inform "Pick up SR, make it lunchbox"
						result, resulturl, advagain = autoadventure(114)
						if result:contains("Lunchboxing") then
							use_item("Knob Goblin lunchbox")
							inform "eating fortune cookie"
							buy_item("fortune cookie", "m")
							local old_full = fullness()
							result, resulturl = eat_item("fortune cookie")
							if fullness() == old_full + 1 then
								did_action = true
							end
						end
						return result, resulturl, did_action
					else
						error "Unknown last SR when picking up SR"
					end
				else
					print("Skipping impossible SR", b, turnsthisrun(), "last", lastsemi, lastturn)
				end
			end
		end
		do
			local SRnow, good_numbers, all_numbers, SRmin, SRmax, is_first_semi, lastsemi = get_semirare_info(turnsthisrun())
			if table.maxn(good_numbers) == 0 and turnsthisrun() < 700 then
				if SRmin <= 10 then
					error "Semirare soon, without fortune cookie numbers"
				end
			end
		end
-- 		if not have_numbers then
-- 			if have(want_itemname) and not ascension["fortune cookie numbers"] then
-- 				buy_item("fortune cookie", "m")
-- 				if not have("fortune cookie") then
-- 					error("Failed to buy a fortune cookie")
-- 				end
-- 				eat_item("fortune cookie")
-- 				eat_item(want_itemname)
-- 				if not ascension["fortune cookie numbers"] then
-- 					error("Failed to get fortune cookie numbers set")
-- 				end
-- 			end
-- 		end
	end

	function f.go(info, zoneid, macro, noncombattbl, buffslist, famname, minmp, extra)
		local specialnoncombatfunction = nil
		local towear = {}
		local finalcheckfunc = nil
		if extra then
			if extra.olfact then
				if not trailed then
					minmp = minmp + 40
				elseif trailed ~= extra.olfact then
					error("Trailing " .. trailed .. " when trying to olfact " .. extra.olfact)
				end
				extra.olfact = nil
			end
			if extra.choice_function then
				specialnoncombatfunction = extra.choice_function
				extra.choice_function = nil
			end
			if extra.equipment then
				towear = extra.equipment
				extra.equipment = nil
			end
			if extra.finalcheck then
				finalcheckfunc = extra.finalcheck
				extra.finalcheck = nil
			end
			unhandled = false
			for a, b in pairs(extra) do
				print("extra." .. a .. " = " .. tostring(b) .. " unhandled!")
				unhandled = "extra." .. a .. " = " .. tostring(b)
			end
			if unhandled then
				error("unhandled: " .. unhandled)
			end
		end
		if mcd() ~= 10 and level() < 13 then
			set_mcd(10)
		elseif mcd() ~= 0 and level() == 13 then
			set_mcd(0)
		end
		inform(info)
		ensure_buffs(buffslist)
		local famt = fam(famname)
		local fammpregen, famequip = famt.mpregen, famt.familiarequip
		f.heal_up()
		if fammpregen then
			if challenge == "fist" then
				f.burn_mp(minmp + 40)
			else
				f.burn_mp(minmp + 20)
			end
		end
		if famequip and not towear.familiarequip and have(famequip) then
			towear.familiarequip = famequip
		elseif famequip == "spangly sombrero" and have(famequip) then -- TODO: hackish for spanglerack
			towear.familiarequip = famequip
		end
		wear(towear)
		ensure_mp(minmp)
		if finalcheckfunc then
			finalcheckfunc()
		end
		result, resulturl, advagain = autoadventure(zoneid, macro, noncombattbl, specialnoncombatfunction)
		did_action = advagain
		if not did_action then
			local need_mainstat = tonumber(result:match("<center>%(You must have at least ([0-9]+) [A-Za-z]+ to adventure here.%)</center>"))
			if need_mainstat and need_mainstat > buffedmainstat() then
				if get_mainstat() == "Muscle" then
					ensure_buffs{"Go Get 'Em, Tiger!"}
				elseif get_mainstat() == "Mysticality" then
					ensure_buffs{"Glittering Eyelashes"}
				elseif get_mainstat() == "Moxie" then
					ensure_buffs{"Butt-Rock Hair"}
				end
				get_page("/charpane.php") -- HACK: Workaround for CDM bug
				if buffedmainstat() >= need_mainstat then
					did_action = true
				end
			end
		end
		return result, resulturl, advagain
	end

	local go = f.go

	function f.coffee_pixie_stick()
		inform "using coffee pixie stick"
		get_page("/town_wrong.php")
		get_page("/arcade.php", { action = "skeeball", pwd = pwd })
		post_page("/arcade.php", { action = "redeem", whichitem = tostring(get_itemid("coffee pixie stick")), quantity = 1 })
		if have("coffee pixie stick") then
			local a = advs()
			local result, resulturl = use_item("coffee pixie stick")
			if advs() > a then
				local did_action = true
				return result, resulturl, did_action
			else
				error("Tried to use pixie stick but didn't gain any adventures")
			end
		else
			error("Didn't get coffee pixie stick")
		end
	end

	function f.finger_cuffs()
		inform "buying finger cuffs"
		result, resulturl = get_page("/town_wrong.php")
		result, resulturl = get_page("/arcade.php", { action = "skeeball", pwd = pwd })
		result, resulturl = post_page("/arcade.php", { action = "redeem", whichitem = tostring(get_itemid("finger cuffs")), quantity = 10 })
		if count("finger cuffs") >= 10 then
			did_action = true
			return result, resulturl, did_action
		else
			error("Didn't get finger cuffs")
		end
	end

	function f.ensure_worthless_item()
		if not (have("worthless trinket") or have("worthless gewgaw") or have("worthless knick-knack")) then
			inform "get worthless item"
			if not have("chewing gum on a string") then
				buy_item("chewing gum on a string", "m")
				if not have("chewing gum on a string") then
					error "Couldn't buy chewing gum"
				end
			end
			result, resulturl = use_item("chewing gum on a string")
			if result:match("You acquire") then
				f.ensure_worthless_item()
			else
				error "Failed to use chewing gum"
			end
		end
		return result, resulturl, did_action
	end

	function f.make_reagent_pasta()
		if count("dry noodles") < 1 then
			ensure_mp(10)
			cast_buff(3006, 1) -- pastamastery
		end
		if count("scrumptious reagent") < 1 then
			ensure_mp(10)
			cast_buff(4006, 1) -- advanced saucecrafting
		end
		if have("Hell broth") then
			inform "make hell ramen"
			result, resulturl = cook_items("Hell broth", "dry noodles")
			if have("Hell ramen") then
				did_action = true
			end
		elseif have("fancy schmancy cheese sauce") then
			inform "make fettucini inconnu"
			result, resulturl = cook_items("fancy schmancy cheese sauce", "dry noodles")
			if have("fettucini Inconnu") then
				did_action = true
			end
		elseif have("hellion cube") then
			inform "make hell broth"
			result, resulturl = cook_items("hellion cube", "scrumptious reagent")
			if have("Hell broth") then
				did_action = true
			end
		elseif have("goat cheese") then
			inform "make cheese sauce"
			result, resulturl = cook_items("goat cheese", "scrumptious reagent")
			if have("fancy schmancy cheese sauce") then
				did_action = true
			end
		end
		return result, resulturl, did_action
	end

	local function get_turns_until_sr()
		local SRnow, good_numbers, all_numbers, SRmin, SRmax, is_first_semi, lastsemi = get_semirare_info(turnsthisrun())
		return good_numbers[1]
	end

	function f.eat_food(day)
		if challenge == "fist" then return end
-- 		TODO: handle without explicitly checking day
		if fullness() < 15 then
			if day == 1 then
				local want_item_tbl = {
					Muscle = "Tiger-lily's milk",
					Mysticality = "powdered donut",
					Moxie = "dragon snaps",
				}
				local want_itemname = want_item_tbl[get_mainstat()]
				if have(want_itemname) and fullness() == 0 then
					inform "eat garden food day 1"
					result, resulturl = eat_item(want_itemname)
					if fullness() == 1 then
						did_action = true
					end
					return result, resulturl, did_action
				elseif not ascension["fortune cookie numbers"] and fullness() == 1 and meat() >= 40 then
					inform "eat fortune cookie day 1"
					buy_item("fortune cookie", "m")
					result, resulturl = eat_item("fortune cookie")
					if ascension["fortune cookie numbers"] then
						did_action = true
					end
					return result, resulturl, did_action
				elseif have("Knob pasty") and fullness() == 2 then
					inform "eat pasty day 1"
					result, resulturl = eat_item("Knob pasty")
					if fullness() == 3 then
						did_action = true
					end
					return result, resulturl, did_action
				elseif fullness() == 3 or fullness() == 9 then
					if have("Hell ramen") then
						inform "eat hell ramen day 1"
						eat_item("Hell ramen")
						if advs() >= 20 then
							did_action = true
						end
						return result, resulturl, did_action
					else
						result, resulturl, did_action = f.make_reagent_pasta()
						if did_action == false and result:contains("You need a more advanced cooking appliance") then
							if have("Dramatic&trade; range") then
								inform "using dramatic range"
								use_item("Dramatic&trade; range")
								if not have("Dramatic&trade; range") then
									did_action = true
								end
							else
								inform "buying dramatic range"
								buy_item("Dramatic&trade; range", "m")
								if have("Dramatic&trade; range") then
									did_action = true
								end
							end
						end
						return result, resulturl, did_action
					end
				end
			elseif day == 2 then
				if get_turns_until_sr() == nil then
					local f = fullness()
					inform "eat fortune cookie day 2"
					buy_item("fortune cookie", "m")
					result, resulturl = eat_item("fortune cookie")
					if fullness() == f + 1 and get_turns_until_sr() ~= nil then
						did_action = true
					end
					return result, resulturl, did_action
				elseif have("Knob pasty") and (fullness() < 3 or fullness() >= 12) then
					inform "eat pasty day 2"
					result, resulturl = eat_item("Knob pasty")
					if advs() >= 20 then
						did_action = true
					end
					return result, resulturl, did_action
				elseif fullness() <= 9 then
					if have("Hell ramen") then
						inform "eat hell ramen day 2"
						eat_item("Hell ramen")
						if advs() >= 20 then
							did_action = true
						end
						return result, resulturl, did_action
					else
						return f.make_reagent_pasta()
					end
				end
			elseif day >= 3 and (advs() <= 100 or get_turns_until_sr() == nil) then
				if get_turns_until_sr() == nil then
					local f = fullness()
					inform "eat fortune cookie day 3"
					buy_item("fortune cookie", "m")
					result, resulturl = eat_item("fortune cookie")
					if fullness() == f + 1 and get_turns_until_sr() ~= nil then
						did_action = true
					end
					return result, resulturl, did_action
				elseif have("Knob pasty") and (fullness() < 3 or fullness() >= 12) then
					inform "eating pasty"
					local a = advs()
					result, resulturl = eat_item("Knob pasty")
					if advs() > a then
						did_action = true
					end
					return result, resulturl, did_action
-- 				elseif fullness() <= 3 and have_reagent_pastas >= need_total_reagent_pastas then
				elseif fullness() <= 3 then
					if count("Hell ramen") + count("fettucini Inconnu") >= 2 then
						if buff("Got Milk") then
							inform "eating reagent pasta"
							eat_item("Hell ramen")
							eat_item("Hell ramen")
							eat_item("fettucini Inconnu")
							eat_item("fettucini Inconnu")
							if fullness() >= 12 then
								did_action = true
							end
							return result, resulturl, did_action
						elseif have("milk of magnesium") then
							inform "using milk"
							result, resulturl = use_item("milk of magnesium")
							if buff("Got Milk") then
								did_action = true
							end
							return result, resulturl, did_action
						elseif have("glass of goat's milk") then
							inform "making milk"
							if count("scrumptious reagent") < 1 then
								ensure_mp(10)
								cast_buff(4006, 1) -- advanced saucecrafting
							end
							result, resulturl = cook_items("glass of goat's milk", "scrumptious reagent")
							if have("milk of magnesium") then
								did_action = true
							end
							return result, resulturl, did_action
						end
					else
						return f.make_reagent_pasta()
					end
				end
			end
		end
	end

	function f.drink_booze(day, forced)
-- 		local function want_to_drink()
-- 			-- TODO: revamp, improve and use this
-- 			if day == 1 and drunkenness() < 3 and have("Typical Tavern swill") and meat() >= 1000 then
-- 				return true
-- 			elseif day == 1 and drunkenness() < 12 and have("Typical Tavern swill") and have("thermos full of Knob coffee") and meat() >= 2000 then
-- 				return true
-- 			elseif day >= 2 and drunkenness() < 19 and ((meat() >= 2000 and advs() <= 20) or forced) then
-- 				return true
-- 			end
-- 			return false
-- 		end
		if challenge == "fist" then return end
		if day == 1 then
			if drunkenness() < 3 and have("Typical Tavern swill") and meat() >= 1000 then
				inform "drinking pumpkin and overpriced beer"
				if not have("pumpkin beer") then
					buy_item("fermenting powder", "m")
					mix_items("pumpkin", "fermenting powder")
				end
				-- IMPROVE?: drink booze and sewerlevel at nice times
				ensure_mp(5)
				cast_buff(8202) -- summon alice's army cards

				ensure_buffs { "Ode to Booze" }
				for i = 1, 10 do
					if drunkenness() < 8 and buff("Ode to Booze") then
						local start_drunk = drunkenness()
						if have("astral pilsner") and level() >= 11 then
							inform "drinking pilsner"
							f.heal_up()
							drink_item("astral pilsner")
						elseif have("thermos full of Knob coffee") then
							inform "drinking knob coffee"
							drink_item("thermos full of Knob coffee")
						elseif have("pumpkin beer") then
							inform "drinking pumpkin beer"
							drink_item("pumpkin beer")
						elseif have("distilled fortified wine") then
							inform "drinking fortified wine"
							drink_item("distilled fortified wine")
						elseif have("Ye Wizard's Shack snack voucher") and drunkenness() <= 7 then
							inform "drinking gamestore sake"
							post_page("/gamestore.php", { action = "buysnack", whichsnack = get_itemid("tobiko-infused sake") })
							drink_item("tobiko-infused sake")
						elseif have("cream stout") then
							inform "drinking cream stout"
							drink_item("cream stout")
						elseif have("shot of rotgut") then
							inform "drinking rotgut"
							f.heal_up()
							drink_item("shot of rotgut")
						else
							inform "drinking imported beer"
							buy_item("overpriced &quot;imported&quot; beer", "v", 1)
							drink_item("overpriced &quot;imported&quot; beer")
						end
						if drunkenness() <= start_drunk then
							error "Failed to drink..."
						end
					end
				end
				if drunkenness() >= 3 and buff("Pisces in the Skyces") then
					did_action = true
				end
				return result, resulturl, did_action
			elseif drunkenness() < 12 and have("Typical Tavern swill") and have("thermos full of Knob coffee") and meat() >= 2000 then
				-- TODO: or we already have cocktailcrafting kit...
				inform "drinking rest for day 1"
				if challenge == "fist" then error "Not drinking automatically in fist" end
				-- TODO: redo
				if not have("coconut shell") and not have("little paper umbrella") and not have("magical ice cubes") then
					ensure_mp(10)
					cast_buff(5014, 1) -- advanced cocktailcrafting
					ensure_mp(10)
					cast_buff(5014, 1) -- advanced cocktailcrafting
					ensure_mp(10)
					cast_buff(5014, 1) -- advanced cocktailcrafting
					ensure_mp(10)
					cast_buff(5014, 1) -- advanced cocktailcrafting
					ensure_mp(10)
					cast_buff(5014, 1) -- advanced cocktailcrafting
				end
				if not have("blended frozen swill") and not have("fruity girl swill") and not have("tropical swill") then
					if have("little paper umbrella") then
						result, resulturl = mix_items("Typical Tavern swill", "little paper umbrella")
					elseif have("magical ice cubes") then
						result, resulturl = mix_items("Typical Tavern swill", "magical ice cubes")
					elseif have("coconut shell") then
						result, resulturl = mix_items("Typical Tavern swill", "coconut shell")
					end
					if have("blended frozen swill") or have("fruity girl swill") or have("tropical swill") then
						did_action = true
					elseif result:contains("Your cocktail set is not advanced enough") then
						if have("Queue Du Coq cocktailcrafting kit") then
							inform "using cocktailcrafting kit"
							use_item("Queue Du Coq cocktailcrafting kit")
							if not have("Queue Du Coq cocktailcrafting kit") then
								did_action = true
							end
						else
							inform "buying cocktailcrafting kit"
							buy_item("Queue Du Coq cocktailcrafting kit", "m")
							if have("Queue Du Coq cocktailcrafting kit") then
								did_action = true
							end
						end
					end
				else
					ensure_buffs { "Ode to Booze" }
					if buffturns("Ode to Booze") < 8 then
						error "Failed to cast ode"
					end
					if have("blended frozen swill") then
						drink_item("blended frozen swill")
					elseif have("fruity girl swill") then
						drink_item("fruity girl swill")
					elseif have("tropical swill") then
						drink_item("fruity girl swill")
					end
					if drunkenness() ~= 12 then
						error "Drunkenness after mixed swill isn't 12"
					end
					local thermoses = count("thermos full of Knob coffee")
					if thermoses > 2 then
						thermoses = 2
					end
					local imported = 2 - thermoses
					buy_item("overpriced &quot;imported&quot; beer", "v", imported)
					for t = 1, thermoses do
						drink_item("thermos full of Knob coffee")
					end
					for i = 1, imported do
						drink_item("overpriced &quot;imported&quot; beer")
					end
					if drunkenness() ~= 14 then
						error "Drunkenness after thermoses/beer isn't 14"
					end
					if buffturns("Ode to Booze") < 8 then
						did_action = true
					else
						error "Something went wrong when drinking booze"
					end
				end
				return result, resulturl, did_action
			end
		elseif day >= 2 then
			if drunkenness() < 19 and ((meat() >= 2000 and advs() <= 20) or (advs() <= 15) or forced) then
				if challenge == "fist" then error "Not drinking automatically in fist" end
-- 				TODOSOON!!! error "Drink better!"
				-- TODO: drink good stuff early, then more good stuff later when you get it from SRs
				if have("pumpkin") then
					buy_item("fermenting powder", "m")
					mix_items("pumpkin", "fermenting powder")
				end
				ensure_mp(5)
				cast_buff(8202) -- summon alice's army cards
				inform "drinking booze"
				if have("steel margarita") then
					error "Drink steel margarita first!"
				end
				for i = 1, 20 do
					if drunkenness() < 19 then
						local start_drunk = drunkenness()
						ensure_buffs { "Ode to Booze" }
						if have("astral pilsner") and level() >= 11 then
							inform "drinking pilsner"
							f.heal_up()
							drink_item("astral pilsner")
						elseif have("thermos full of Knob coffee") then
							inform "drinking knob coffee"
							drink_item("thermos full of Knob coffee")
						elseif have("pumpkin beer") then
							inform "drinking pumpkin beer"
							drink_item("pumpkin beer")
						elseif have("distilled fortified wine") then
							inform "drinking fortified wine"
							drink_item("distilled fortified wine")
						elseif have("Ye Wizard's Shack snack voucher") and drunkenness() <= 16 then
							inform "drinking gamestore sake"
							post_page("/gamestore.php", { action = "buysnack", whichsnack = get_itemid("tobiko-infused sake") })
							drink_item("tobiko-infused sake")
						elseif have("Supernova Champagne") and drunkenness() <= 16 then
							inform "drinking champagne"
							drink_item("Supernova Champagne")
						elseif have("cream stout") then
							inform "drinking cream stout"
							drink_item("cream stout")
						elseif have("shot of rotgut") then
							inform "drinking rotgut"
							f.heal_up()
							drink_item("shot of rotgut")
						else
							if challenge == "fist" then
								error "Not drinking imported beer in fist"
							end
							inform "drinking imported beer"
							buy_item("overpriced &quot;imported&quot; beer", "v", 1)
							if not have("overpriced &quot;imported&quot; beer") then
								error "Failed to buy imported beer"
							end
							drink_item("overpriced &quot;imported&quot; beer")
						end
						if drunkenness() <= start_drunk then
							error "Failed to drink..."
						end
					end
				end
				if drunkenness() == 19 then
					did_action = true
				end
				return result, resulturl, did_action
			end
		end
	end

	function f.get_photocopied_monster()
		if have("photocopied monster") then
			local itempt = get_page("/desc_item.php", { whichitem = "835898159" })
			local copied = itempt:match([[blurry likeness of [a-zA-Z]* (.-) on it.]])
			return copied
		else
			return nil
		end
	end

	function f.unlock_cobbs_knob()
		if have("Knob Goblin encryption key") then
			result, resulturl = use_item("Cobb's Knob map")
			refresh_quest()
			if not quest_text("haven't figured out how to decrypt it yet") then
				did_action = true
			end
		else
			go("get encryption key", 114, macro_stasis(), {
				["Up In Their Grill"] = "Grab the sausage, so to speak.  I mean... literally.",
				["Knob Goblin BBQ"] = "Kick the chef",
				["Ennui is Wasted on the Young"] = "&quot;Since you're bored, you're boring.  I'm outta here.&quot;",
				["Malice in Chains"] = "Plot a cunning escape",
				["When Rocks Attack"] = "&quot;Sorry, gotta run.&quot;",
			}, {}, "Mini-Hipster", 15)
			if have("Knob Goblin encryption key") then
				did_action = true
			end
		end
	end

	function f.do_barrr(insults)
		if insults >= 7 and have("Cap'm Caronch's Map") then
			inform "use cap'm's map"
			ensure_buffs { "Springy Fusilli", "Spirit of Peppermint" }
			fam "Rogue Program"
			ensure_mp(40)
			local pt, url = use_item("Cap'm Caronch's Map")
			local pt, url = get_page("/fight.php")
			result, resulturl, advagain = handle_adventure_result(pt, url, "?", macro_noodlecannon())
			if advagain then
				did_action = true
			end
		else
-- 			print("map", have("Cap'm Caronch's Map"), "insults", insults)
			local function get_barrr_noncombattbl()
				if get_mainstat() == "Muscle" then
						return {
								["Yes, You're a Rock Starrr"] = "Sing the Southern Hey Deze tune &quot;Fiends in Low Places.&quot;",
								["A Test of Testarrrsterone"] = "Cheat",
								["That Explains All The Eyepatches"] = "Carefully throw the darrrt at the tarrrget",
						}
				elseif get_mainstat() == "Mysticality" then
						return {
								["Yes, You're a Rock Starrr"] = "Sing the Southern Hey Deze tune &quot;Fiends in Low Places.&quot;",
								["A Test of Testarrrsterone"] = "Cheat",
								["That Explains All The Eyepatches"] = "Pull one over on the pirates",
						}
				elseif get_mainstat() == "Moxie" then
						return {
								["Yes, You're a Rock Starrr"] = "Sing the Southern Hey Deze tune &quot;Fiends in Low Places.&quot;",
								["A Test of Testarrrsterone"] = "Wuss out",
								["That Explains All The Eyepatches"] = "Carefully throw the darrrt at the tarrrget",
						}
				end
			end
			go("doing barrr", 157, macro_barrr(), get_barrr_noncombattbl(), { "Smooth Movements", "The Sonata of Sneakiness", "Fat Leon's Phat Loot Lyric", "Spirit of Bacon Grease" }, "Rogue Program", 30, { equipment = { hat = "eyepatch", pants = "swashbuckling pants", acc1 = "stuffed shoulder parrot" } })
		end
	end

	function f.beat_ibp()
		inform "beat IBP"
		wear { hat = "eyepatch", pants = "swashbuckling pants", acc1 = "stuffed shoulder parrot" }

-- 		TODO: merge with pirates.lua
		local beer_pong_responses = {
			["Arrr, the power of me serve'll flay the skin from yer bones!"] = "Obviously neither your tongue nor your wit is sharp enough for the job.",
			["Do ye hear that, ye craven blackguard?  It be the sound of yer doom!"] = "It can't be any worse than the smell of your breath!",
			["Suck on <i>this</i>, ye miserable, pestilent wretch!"] = "That reminds me, tell your wife and sister I had a lovely time last night.",
			["The streets will run red with yer blood when I'm through with ye!"] = "I'd've thought yellow would be more your color.",
			["Yer face is as foul as that of a drowned goat!"] = "I'm not really comfortable being compared to your girlfriend that way.",
			["When I'm through with ye, ye'll be crying like a little girl!"] = "It's an honor to learn from such an expert in the field.",
			["In all my years I've not seen a more loathsome worm than yerself!"] = "Amazing!  How do you manage to shave without using a mirror%?",
			["Not a single man has faced me and lived to tell the tale!"] = "It only seems that way because you haven't learned to count to one.",
		}

		local function solve_beerpong(n)
			if n <= 0 then return end
			local choice = nil
			for from, to in pairs(beer_pong_responses) do
				if result:contains(from) then
					choice = to
				end
			end
			if choice and result:match(choice) then
				responsenum = tonumber(result:match("<option value=([0-9]+)>"..choice.."</option>"))
				print("choose choice ", choice, responsenum)
				if responsenum then
					result, resulturl = post_page("/beerpong.php", { response = responsenum })
					return solve_beerpong(n - 1)
				end
	-- 		else
	-- 			print(text)
			end
		end
		result, resulturl, advagain = autoadventure(157)
		result, resulturl = post_page("/choice.php", { pwd = pwd, whichchoice = 187, option = 1 })
		solve_beerpong(3)
		refresh_quest()
		if not quest_text("wants you to defeat Old Don Rickets") then
			did_action = true
		end
	end

	function f.do_battlefield()
		if have("heart of the filthworm queen") then
			inform "try to turn in filthworm heart"
			wear { hat = "beer helmet", pants = "distressed denim pants", acc1 = "bejeweled pledge pin" }
			get_page("/bigisland.php", { place = "orchard", action = "stand", pwd = pwd })
			get_page("/bigisland.php", { place = "orchard", action = "stand", pwd = pwd })
		end
-- 			TODO: use PADL phone
-- 		error "TODO use PADL"
		use_dancecard()
		local macro_battlefield = [[
if monstername green ops
]] .. macro_noodlegeyser(3) .. [[

  goto m_done
endif

]] .. macro_noodlecannon() .. [[

mark m_done

]]
		go("fight on battlefield: " .. tostring(ascension["battlefield.kills.frat boy.min"]) .. " hippies killed", 132, macro_battlefield, nil, { "Fat Leon's Phat Loot Lyric", "Spirit of Bacon Grease" }, "Slimeling for real", 80, { equipment = { hat = "beer helmet", pants = "distressed denim pants", acc1 = "bejeweled pledge pin" } })
		if result:contains("There are no hippy soldiers left") then
			local turnins = {
				"green clay bead",
				"pink clay bead",
				"purple clay bead",
				"communications windchimes",
			}
			for _, x in pairs(turnins) do
				if have(x) then
					get_page("/bigisland.php", { action = "turnin", pwd = pwd, whichcamp = 2, whichitem = get_itemid(x), quantity = count(x) })
				end
			end
			local camppt = get_page("/bigisland.php", { place = "camp", whichcamp = "2" })
			if camppt:contains("You don't have any quarters on file") then
				inform "fight hippy boss"
				fam "Frumious Bandersnatch"
				f.heal_up()
				ensure_mp(150)
				ensure_buffs { "Jalape&ntilde;o Saucesphere", "Jaba&ntilde;ero Saucesphere", "Spirit of Garlic", "Astral Shell", "Ghostly Shell", "A Few Extra Pounds", "Mental A-cue-ity" }
				result, resulturl = get_page("/bigisland.php", { place = "camp", whichcamp = "1" })
				result, resulturl = get_page("/bigisland.php", { action = "bossfight", pwd = pwd })
				result, resulturl, advagain = handle_adventure_result(result, resulturl, "?", macro_noodlegeyser(7))
				if advagain then
					did_action = true
				end
			else
				if count("gauze garter") < 10 then
					inform "buying gauze garters"
					post_page("/bigisland.php", { action = "getgear", pwd = pwd, whichcamp = 2, whichitem = get_itemid("gauze garter"), quantity = 10 })
					if count("gauze garter") >= 10 then
						did_action = true
					end
				elseif count("superamplified boom box") < 2 then
					inform "buying boom boxes"
					post_page("/bigisland.php", { action = "getgear", pwd = pwd, whichcamp = 2, whichitem = get_itemid("superamplified boom box"), quantity = 2 })
					if count("superamplified boom box") >= 2 then
						did_action = true
					end
				else
					inform "spending remaining quarters"
					post_page("/bigisland.php", { action = "getgear", pwd = pwd, whichcamp = 2, whichitem = get_itemid("superamplified boom box"), quantity = 1 })
					post_page("/bigisland.php", { action = "getgear", pwd = pwd, whichcamp = 2, whichitem = get_itemid("gauze garter"), quantity = 1 })
					post_page("/bigisland.php", { action = "getgear", pwd = pwd, whichcamp = 2, whichitem = get_itemid("gauze garter"), quantity = 1 })
					post_page("/bigisland.php", { action = "getgear", pwd = pwd, whichcamp = 2, whichitem = get_itemid("superamplified boom box"), quantity = 1 })
					post_page("/bigisland.php", { action = "getgear", pwd = pwd, whichcamp = 2, whichitem = get_itemid("commemorative war stein"), quantity = 32 })
					post_page("/bigisland.php", { action = "getgear", pwd = pwd, whichcamp = 2, whichitem = get_itemid("commemorative war stein"), quantity = 16 })
					post_page("/bigisland.php", { action = "getgear", pwd = pwd, whichcamp = 2, whichitem = get_itemid("commemorative war stein"), quantity = 8 })
					post_page("/bigisland.php", { action = "getgear", pwd = pwd, whichcamp = 2, whichitem = get_itemid("commemorative war stein"), quantity = 4 })
					post_page("/bigisland.php", { action = "getgear", pwd = pwd, whichcamp = 2, whichitem = get_itemid("commemorative war stein"), quantity = 2 })
					post_page("/bigisland.php", { action = "getgear", pwd = pwd, whichcamp = 2, whichitem = get_itemid("commemorative war stein"), quantity = 1 })
					post_page("/bigisland.php", { action = "getgear", pwd = pwd, whichcamp = 2, whichitem = get_itemid("superamplified boom box"), quantity = 1 })
					post_page("/bigisland.php", { action = "getgear", pwd = pwd, whichcamp = 2, whichitem = get_itemid("gauze garter"), quantity = 1 })
					post_page("/bigisland.php", { action = "getgear", pwd = pwd, whichcamp = 2, whichitem = get_itemid("sake bomb"), quantity = 1 })
					local newcamppt = get_page("/bigisland.php", { place = "camp", whichcamp = 2 })
					if newcamppt:contains("You don't have any quarters on file") then
						did_action = true
					end
				end
			end
		end
	end

	function f.get_flyers()
		inform "get rock band flyers"
		get_page("/bigisland.php", { place = "concert" })
		if have("rock band flyers") then
			did_action = true
		else
			inform "check if done with war prep"
			wear { hat = "beer helmet", pants = "distressed denim pants", acc1 = "bejeweled pledge pin" }
			concertpt = get_page("/bigisland.php", { place = "concert" })
			junkmanpt = get_page("/bigisland.php", { action = "junkman", pwd = pwd })
			pyropt = get_page("/bigisland.php", { place = "lighthouse", action = "pyro", pwd = pwd })
			if concertpt:contains("has already taken the stage") and junkmanpt:contains("next shipment of cars ready") and pyropt:contains("gave you the big boom today") then
				inform "pick up padl phone"
				result, resulturl, advagain = autoadventure(132)
				if have("PADL Phone") then
					did_action = true
				end
			else
				error "Not done with war prep when starting to fight war"
			end
		end
	end

	function f.do_manor_of_spooking()
		local manorpt = get_page("/manor.php")
		if not manorpt:match("To The Cellar") then
			go("unlock cellar", 109, macro_noodlecannon(), {
				["Curtains"] = "Watch the dancers",
				["Strung-Up Quartet"] = "&quot;Play nothing, please.&quot;",
			}, { "Smooth Movements", "The Sonata of Sneakiness", "Fat Leon's Phat Loot Lyric", "Spirit of Garlic" }, "Slimeling", 30)
		elseif not have("Lord Spookyraven's spectacles") then
			go("get spectacles", 108, macro_noodleserpent(), {}, { "Smooth Movements", "The Sonata of Sneakiness", "Springy Fusilli", "Spirit of Garlic" }, "Rogue Program", 50, { choice_function = function (advtitle, choicenum)
				if choicenum == 82 then
					return "Kick it and see what happens"
				elseif choicenum == 83 then
					return "Check the bottom drawer"
				elseif choicenum == 84 then
					return "Look behind the nightstand"
				elseif choicenum == 85 then
					if get_mainstat() == "Moxie" then
						return "Check the top drawer"
					else
						return "Investigate the jewelry"
					end
				end
			end })
		elseif not ascension["zone.manor.wines needed"] then
			inform "determine cellar wines"
			determine_cellar_wines()
			if ascension["zone.manor.wines needed"] then
				print("got wine state set now!")
				did_action = true
			end
		else
			local manor3pt = get_page("/manor3.php")
			local wines_needed_list = ascension["zone.manor.wines needed"]
			local need = 0
			local got = 0
			local missing = {}
			for _, wine in pairs(wines_needed_list) do
				need = need + 1
				if have(wine) then
					got = got + 1
				else
					missing[wine] = true
				end
			end
			if need ~= 3 then
				error("not 3 wines needed for cellar")
			elseif manor3pt:match("Summoning Chamber") then
				inform "fight spookyraven"
				ensure_buffs { "Springy Fusilli", "Astral Shell", "Jaba&ntilde;ero Saucesphere", "Spirit of Bacon Grease", "Jalape&ntilde;o Saucesphere" }
				fam "Frumious Bandersnatch"
				use_hottub()
				ensure_mp(50)
				local pt, url = get_page("/manor3.php", { place = "chamber" })
				result, resulturl, advagain = handle_adventure_result(pt, url, "?", macro_spookyraven())
				if advagain then
					did_action = true
				end
			elseif got >= need then
				inform "open chamber"
				for _, wine in pairs(wines_needed_list) do
					post_page("/manor3.php", { action = "pourwine", whichwine = get_itemid(wine) })
				end
				local manor3pt = get_page("/manor3.php")
				if manor3pt:match("Summoning Chamber") then
					did_action = true
				end
			else
				if not have("sugar shield") then
					get_page("/sugarsheets.php", { pwd = pwd, action = "fold", whichitem = get_itemid("sugar shield") })
				end
				local wines, _ = get_wine_cellar_data(ascension["zone.manor.wine cellar bottles"] or {})
-- 				print("wines", table_to_str(wines))
				local best = -1
				local best_zones = nil
				for z, ztbl in pairs(wines) do
					local score = 0
					for x, xv in pairs(ztbl) do
						if missing[x] then score = score + xv end
					end
-- 					print("zone", z, score)
					if score > best then
						best = score
						best_zones = { z }
					elseif score == best then
						table.insert(best_zones, z)
					end
				end
				local next_zone = best_zones[math.random(table.maxn(best_zones))]
-- 				print("bestzone", table_to_str(best_zones), best, "going to", next_zone)
				go("get cellar wines", next_zone, macro_noodleserpent(), {}, { "Spirit of Bacon Grease", "Fat Leon's Phat Loot Lyric", "Heavy Petting", "Peeled Eyeballs", "Leash of Linguini", "Empathy" }, "Slimeling", 50)
				if did_action then
					wear {}
				end
			end
		end
	end

	function f.do_gotta_worship_them_all()
		local woodspt = get_page("/woods.php")
		if not woodspt:contains("The Hidden Temple") then
			f.unlock_hidden_temple()
		elseif not woodspt:match("hiddencity") then
			go("unlock hidden city", 17, macro_noodlecannon(), {
				["At Least It's Not Full Of Trash"] = "Raise your hands up toward the heavens",
				["No Visible Means of Support"] = "Do nothing",
			}, { "Spirit of Bacon Grease" }, "Mini-Hipster", 25)

			if resulturl:match("/tiles.php") then
				print("doing temple tiles")
				result, resulturl = automate_tiles()
				if result:match("thank goodness that's over") then
					did_action = true
				end
			end

			if result:match("You mark its location on your map, and carefully climb down the side of the Temple, back to ground level.") then
				did_action = true
			end
		else
			local hiddencitypt = get_page("/hiddencity.php")
			local count_spheres_stones = count("cracked stone sphere") + count("mossy stone sphere") + count("rough stone sphere") + count("smooth stone sphere") + count("triangular stone")
			local altars = 0
			for x in hiddencitypt:gmatch("map_altar.gif") do
				altars = altars + 1
			end
			if count_spheres_stones == 4 and altars == 4 and hiddencitypt:contains("map_temple.gif") then
				if count("triangular stone") == 4 then
					inform "fight hidden city boss"
					local temple_which = nil
					for which, tiletext in hiddencitypt:gmatch([[<a href='hiddencity.php%?which=([0-9]+)'>(.-)</a>]]) do
						if tiletext:contains("map_temple.gif") then
							temple_which = which
						end
					end
					if temple_which then
						ensure_buffs { "Spirit of Peppermint", "Jaba&ntilde;ero Saucesphere", "Jalape&ntilde;o Saucesphere" }
						fam "Mini-Hipster"
						f.heal_up()
						f.burn_mp(90)
						ensure_mp(80)
						get_page("/hiddencity.php", { which = temple_which })
						post_page("/hiddencity.php", { action = "trisocket" })
						result, resulturl = get_page("/fight.php")
						result, resulturl, advagain = handle_adventure_result(result, resulturl, "?", macro_noodlegeyser(5))
						if have("ancient amulet") then
							did_action = true
						end
					end
				else
					inform "use spheres, get stones..."
					local altar_solutions = get_stone_sphere_status().altars
					for which, tiletext in hiddencitypt:gmatch([[<a href='hiddencity.php%?which=([0-9]+)'>(.-)</a>]]) do
						if tiletext:contains("map_altar.gif") then
-- 								print("hiddencity altar", which, tiletext)
							local altarpt = get_page("/hiddencity.php", { which = which })
							if altarpt:contains("<form") then
								for a, b in pairs(altar_solutions) do
									if altarpt:match("<table><tr><td><table><tr><td valign=center><img src='http://images.kingdomofloathing.com/otherimages/hiddencity/altar[0-9].gif' alt='An altar with a carving of a god of "..a.."' title='An altar with a carving of a god of "..a.."'></td><td><b>Altared Perceptions</b><p>You discover a stone altar, elaborately carved with a depiction of what appears to be some kind of ancient god.</td></tr></table>The top of the altar features a bowl%-like depression %-%- it looks as though you're meant to put something into it. Probably something round.<p>") then
										print("put", b, get_itemid(b .. " stone sphere"), "in", which)
										post_page("/hiddencity.php", { action = "roundthing", whichitem = get_itemid(b .. " stone sphere") })
									end
								end
							end
						end
					end
					if count("triangular stone") == 4 then
						did_action = true
					end
				end
			else
				local which = hiddencitypt:match([[<a href='hiddencity.php%?which=([0-9]-)'><img src="http://images.kingdomofloathing.com/otherimages/hiddencity/map_unruins]])
				if which then
					inform("do hidden city (" .. which .. ")")
					ensure_buffs { "Spirit of Peppermint", "Jaba&ntilde;ero Saucesphere", "Jalape&ntilde;o Saucesphere" }
					fam "Mini-Hipster"
					f.heal_up()
					f.burn_mp(90)
					ensure_mp(80)
					local pt, url = get_page("/hiddencity.php", { which = which })
					result, resulturl, advagain = handle_adventure_result(pt, url, "?", macro_hiddencity())
					if advagain or result:match([[Altared Perceptions]]) or result:match([[Mansion House of the Black Friars]]) or result:match([[Dr. Henry "Dakota" Fanning, Ph.D., R.I.P.]]) then
						did_action = true
					elseif resulturl:match("/adventure.php") and result:match([[<a href="hiddencity.php">Go back to The Hidden City</a>]]) then
						did_action = true
					end
				else
					error "Nothing to do in hidden city, but don't have all spheres"
				end
			end
		end
	end

	function f.do_pyramid()
		local pyramidpt = get_page("/pyramid.php")
		if challenge == "fist" then
			error "Redo pyramid in fist, do ratchets"
		end
		if pyramidpt:match("pyramid3a.gif") then
			if not have("carved wooden wheel") then
				go("find carved wheel", 124, macro_noodleserpent(), nil, { "Spirit of Bacon Grease" }, "Mini-Hipster", 45)
			else
				go("place wheel in middle chamber", 125, macro_noodleserpent(), {
					["Wheel in the Pyramid, Keep on Turning"] = "Turn the wheel",
				}, { "Smooth Movements", "The Sonata of Sneakiness", "Spirit of Bacon Grease" }, "Rogue Program", 45)
			end
		else
-- 			pyramid4_1.gif -> nuke
-- 			pyramid4_2.gif -> turn
-- 			pyramid4_3.gif -> bomb
-- 			pyramid4_4.gif -> token
-- 			pyramid4_5.gif -> turn
			if pyramidpt:match("pyramid4_1b.gif") then
				-- TODO: check if this will overlap with SR
				inform "fight ed"
				fam "Frumious Bandersnatch"
				f.heal_up()
				ensure_buffs { "Jalape&ntilde;o Saucesphere", "Jaba&ntilde;ero Saucesphere", "Spirit of Garlic", "Astral Shell", "Ghostly Shell", "A Few Extra Pounds", "Mental A-cue-ity" }
				ensure_mp(100)
				result, resulturl = get_page("/pyramid.php", { action = "lower" })
				result, resulturl, advagain = handle_adventure_result(result, resulturl, "?", macro_noodlegeyser(5))
				while result:contains([[<!--WINWINWIN-->]]) and result:contains([[fight.php]]) do
					result, resulturl = get_page("/fight.php")
					result, resulturl, advagain = handle_adventure_result(result, resulturl, "?", macro_noodlegeyser(5))
				end
				if have("Holy MacGuffin") then
					did_action = true
				end
			elseif pyramidpt:match("pyramid4_1.gif") and have("ancient bomb") then
				inform "use bomb"
				get_page("/pyramid.php", { action = "lower" })
				pyramidpt = get_page("/pyramid.php")
				if pyramidpt:match("pyramid4_1b.gif") then
					did_action = true
				end
			elseif pyramidpt:match("pyramid4_3.gif") and not have("ancient bomb") and have("ancient bronze token") then
				inform "buy bomb"
				get_page("/pyramid.php", { action = "lower" })
				if have("ancient bomb") then
					did_action = true
				end
			elseif pyramidpt:match("pyramid4_4.gif") and not have("ancient bomb") and not have("ancient bronze token") then
				inform "get token"
				get_page("/pyramid.php", { action = "lower" })
				if have("ancient bronze token") then
					did_action = true
				end
			elseif pyramidpt:match("pyramid4_[12345].gif") then
				go("turn middle chamber wheel", 125, macro_noodleserpent(), {
					["Wheel in the Pyramid, Keep on Turning"] = "Turn the wheel",
				}, { "Smooth Movements", "The Sonata of Sneakiness", "Spirit of Bacon Grease" }, "Rogue Program", 45)
			end
		end
	end

	function f.do_filthworms()
		inform "do filthworms"
		if buff("Filthworm Guard Stench") then
			if not have("sugar shield") then
				get_page("/sugarsheets.php", { pwd = pwd, action = "fold", whichitem = get_itemid("sugar shield") })
			end
			go("fight queen", 130, macro_noodlecannon(), {}, { "Spirit of Bacon Grease" }, "Hobo Monkey", 30, { equipment = { familiarequip = "sugar shield" } })
			if did_action then
				wear {}
			end
		elseif have("filthworm royal guard scent gland") then
			use_item("filthworm royal guard scent gland")
			if buff("Filthworm Guard Stench") then
				did_action = true
			end
		elseif buff("Filthworm Drone Stench") then
			if not have("sugar shield") then
				get_page("/sugarsheets.php", { pwd = pwd, action = "fold", whichitem = get_itemid("sugar shield") })
			end
			go("fight guard", 129, macro_ppnoodlecannon(), {}, { "Spirit of Bacon Grease", "Fat Leon's Phat Loot Lyric", "Heavy Petting", "Peeled Eyeballs", "Leash of Linguini", "Empathy" }, "Slimeling", 30, { equipment = { hat = "miner's helmet", familiarequip = "sugar shield" } })
			if did_action then
				wear {}
			end
		elseif have("filthworm drone scent gland") then
			use_item("filthworm drone scent gland")
			if buff("Filthworm Drone Stench") then
				did_action = true
			end
		elseif buff("Filthworm Larva Stench") then
			if not have("sugar shield") then
				get_page("/sugarsheets.php", { pwd = pwd, action = "fold", whichitem = get_itemid("sugar shield") })
			end
			go("fight drone", 128, macro_ppnoodlecannon(), {}, { "Spirit of Bacon Grease", "Fat Leon's Phat Loot Lyric", "Heavy Petting", "Peeled Eyeballs", "Leash of Linguini", "Empathy" }, "Slimeling", 30, { equipment = { hat = "miner's helmet", familiarequip = "sugar shield" } })
			if did_action then
				wear {}
			end
		elseif have("filthworm hatchling scent gland") then
			use_item("filthworm hatchling scent gland")
			if buff("Filthworm Larva Stench") then
				did_action = true
			end
		else
			if not have("sugar shield") then
				get_page("/sugarsheets.php", { pwd = pwd, action = "fold", whichitem = get_itemid("sugar shield") })
			end
			go("fight hatchling", 127, macro_ppnoodlecannon(), {}, { "Spirit of Bacon Grease", "Fat Leon's Phat Loot Lyric", "Heavy Petting", "Peeled Eyeballs", "Leash of Linguini", "Empathy" }, "Slimeling", 30, { equipment = { hat = "miner's helmet", familiarequip = "sugar shield" } })
			if did_action then
				wear {}
			end
		end
	end

	function f.do_sonofa()
		if count("barrel of gunpowder") >= 5 then
			inform "talk to lighthouse guy"
			wear { hat = "beer helmet", pants = "distressed denim pants", acc1 = "bejeweled pledge pin" }
			get_page("/bigisland.php", { place = "lighthouse", action = "pyro", pwd = pwd })
			get_page("/bigisland.php", { place = "lighthouse", action = "pyro", pwd = pwd })
			equip_item("yak toupee")
			if have("tequila grenade") and have("molotov cocktail cocktail") then
				did_action = true
			end
		else
			if not buff("Hippy Stench") and have("reodorant") then
				use_item("reodorant")
			end
			if not have("sugar shield") then
				get_page("/sugarsheets.php", { pwd = pwd, action = "fold", whichitem = get_itemid("sugar shield") })
			end
			go("do sonofa beach, " .. count("barrel of gunpowder") .. " barrels", 136, macro_noodleserpent(), {}, { "Spirit of Bacon Grease", "Musk of the Moose", "Carlweather's Cantata of Confrontation", "Heavy Petting", "Leash of Linguini", "Empathy" }, "Jumpsuited Hound Dog for +combat", 50, { equipment = { familiarequip = "sugar shield" } })
			if did_action then
				wear {}
			end
		end
	end

	function f.do_junkyard()
		wear { hat = "beer helmet", pants = "distressed denim pants", acc1 = "bejeweled pledge pin" }
		if not have("molybdenum magnet") then
			get_page("/bigisland.php", { action = "junkman", pwd = pwd })
		end
		ensure_buffs { "Spirit of Bacon Grease", "Astral Shell", "Ghostly Shell", "A Few Extra Pounds" }
		fam "Frumious Bandersnatch"
		f.heal_up()
		ensure_mp(100)
		if not have("molybdenum hammer") then
			inform "get gremlin hammer"
			result, resulturl, advagain = autoadventure(182, make_gremlin_macro("batwinged gremlin", "a bombing run"))
			did_action = advagain
		elseif not have("molybdenum crescent wrench") then
			inform "get gremlin wrench"
			result, resulturl, advagain = autoadventure(184, make_gremlin_macro("erudite gremlin", "random junk"))
			did_action = advagain
		elseif not have("molybdenum pliers") then
			inform "get gremlin pliers"
			result, resulturl, advagain = autoadventure(183, make_gremlin_macro("spider gremlin", "fibula"))
			did_action = advagain
		elseif not have("molybdenum screwdriver") then
			inform "get gremlin screwdriver"
			result, resulturl, advagain = autoadventure(185, make_gremlin_macro("vegetable gremlin", "picks a"))
			did_action = advagain
		end
		get_page("/bigisland.php", { action = "junkman", pwd = pwd })
	end

	function f.do_trapper_quest()
		inform "do trapper quest"
		if quest_text("wants you to infiltrate Itznotyerzitz Mine") then
			get_page("/trapper.php")
			refresh_quest()
			if quest_text("bring him 6 chunks of goat cheese") then
				did_action = true
			else
				inform "TODO: get ore"
				if challenge == "fist" then
					ensure_buffs { "Earthen Fist" }
				else
					wear { hat = "miner's helmet", weapon = "7-Foot Dwarven mattock", pants = "miner's pants" }
				end
				result, resulturl = get_page("/mining.php", { mine = 1 })
				did_action = false
			end
		elseif quest_text("bring him 6 chunks of goat cheese") and count("goat cheese") < 6 then
			-- "Brother Flying Burrito's Blessing", picked up at end of day 2, just hope it works out?
			go("get goat cheese for trapper", 60, make_cannonsniff_macro("dairy goat"), nil, { "Fat Leon's Phat Loot Lyric", "Heavy Petting", "Peeled Eyeballs", "Leash of Linguini", "Empathy" }, "Slimeling", 30, { olfact = "dairy goat" })
			if result:contains("Between a Rock and Some Other Rocks") then
				result, resulturl, advagain = handle_adventure_result(result, resulturl, 60, nil, { ["Between a Rock and Some Other Rocks"] = "Screw these rocks, I'm gonna roll out" })
				if advagain then
					if challenge == "fist" then
						go("open goatlet", 60, nil, { ["Between a Rock and Some Other Rocks"] = "Help the miners clear the rocks away" }, { "Earthen Fist" }, "Slimeling", 30)
					else
						go("open goatlet", 60, nil, { ["Between a Rock and Some Other Rocks"] = "Help the miners clear the rocks away" }, {}, "Slimeling", 30, { equipment = { hat = "miner's helmet", weapon = "7-Foot Dwarven mattock", pants = "miner's pants" } })
					end
					did_action = false
					if result:contains("you clear the way to the Goatlet") then
						did_action = true
					end
					wear {}
				end
			end
		else
			ensure_buffs { "Astral Shell" }
			fam "Exotic Parrot"
			get_page("/trapper.php")
			get_page("/trapper.php")
			refresh_quest()
			if quest("Am I my Trapper's Keeper?") then
				error "Failed to finish trapper quest"
			end
			if have("astral shirt") then
				did_action = true
			elseif challenge == "fist" then
				did_action = true
			else
				post_page("/trapper.php", { action = "Yep.", pwd = pwd, whichitem = get_itemid("yak skin"), qty = 1 })
				if have("yak skin") then
					inform "smith and wear yak stuff"
					if not have("tenderizing hammer") then
						buy_item("tenderizing hammer", "s")
					end
					if not have("shirt kit") then
						buy_item("shirt kit", "s")
					end
					smith_items_craft("shirt kit", "yak skin")
					if have("yak anorak") then
						did_action = true
					end
				end
			end
		end
	end

	function f.do_muscle_powerleveling()
		print("mainstat", basemainstat(), "advs", advs())
		if have("Spookyraven gallery key") then
			local function find_solution(from_choicenum)
				local found = {}
				local reached = {}
				local available = {}
				available[from_choicenum] = -1000
				for i = 1, 1000 do
					local new_available = {}
					local found_any = false
					for choicenum, source in pairs(available) do
						found_any = true
						reached[choicenum] = source
						for initialc = 1, 3 do
							local initialto = ascension["louvre.map.adventure." .. choicenum .. ".choice." .. initialc]
							if initialto then
								local tochoice = initialto:match("^choice ([0-9]+)$")
								local toresult = initialto:match("^result (.+)$")
								if tochoice then
									if not reached[tochoice] and not available[tochoice] then
										new_available[tochoice] = { whichchoice = choicenum, option = initialc }
									end
								end
								if toresult then
									if not found[toresult] then
										found[toresult] = { whichchoice = choicenum, option = initialc }
									end
								end
							end
						end
					end
					available = new_available
					if not found_any then
						break
					end
				end
				return found, reached
			end
			go("muscle powerleveling", 106, macro_noodlecannon(), {}, { "Smooth Movements", "The Sonata of Sneakiness", "Spirit of Garlic", "Butt-Rock Hair", "A Few Extra Pounds" }, "Rogue Program", 35, { choice_function = function (advtitle, choicenum)
				if advtitle == "Out in the Garden" then
					return "The second knight"
				else
					local found, reached = find_solution(choicenum)
					local mus = found["Gain muscle"]
					if mus then
						function trace(source)
							if source == -1000 then
								return {}
							else
								local tbl = trace(reached[source.whichchoice])
								table.insert(tbl, source)
								return tbl
							end
						end
						local t = trace(mus)
						if t[1].whichchoice == choicenum then
							return "", t[1].option
						else
							error "TODO: Explore louvre to locate muscle adventure"
						end
					end
				end
			end})
		elseif ascension["zone.conservatory.gallery key"] == "unlocked" then
			go("pick up gallery key", 103, macro_stasis(), {}, {}, "Mini-Hipster", 15)
		else
			go("unlock gallery key", 104, macro_stasis(), {}, {"Smooth Movements", "The Sonata of Sneakiness", "Butt-Rock Hair", "A Few Extra Pounds"}, "Rogue Program", 5, { choice_function = function (advtitle, choicenum)
				if advtitle == "Take a Look, it's in a Book!" then
					if choicenum == 80 then
						return "Reading is for losers.  I'm outta here."
					elseif choicenum == 81 then
						return "Read &quot;The Fall of the House of Spookyraven&quot;"
					end
				elseif advtitle == "History is Fun!" then
					return "Read Chapter 2: Stephen and Elizabeth"
				end
			end})
		end
	end

	function f.do_mysticality_powerleveling()
		print("mainstat", basemainstat(), "advs", advs())
		go("mysticality powerleveling", 107, macro_noodlecannon(), {
			["Don't Hold a Grudge"] = "Declare a thumb war",
			["Having a Medicine Ball"] = "Gaze deeply into the mirror",
		}, { "Smooth Movements", "The Sonata of Sneakiness", "Spirit of Garlic" }, "Rogue Program", 25)
	end

	function f.do_moxie_powerleveling()
		print("mainstat", basemainstat(), "dance cards", count("dance card"), "advs", advs(), "trail turns", buffturns("On the Trail"))
		go("moxie powerleveling", 109, make_cannonsniff_macro("zombie waltzers"), {
			["Curtains"] = "Watch the dancers",
			["Strung-Up Quartet"] = "&quot;Play 'Sono Un Amanten Non Un Combattente'&quot;",
		}, { "Smooth Movements", "The Sonata of Sneakiness", "Spirit of Garlic", "Fat Leon's Phat Loot Lyric" }, "Slimeling", 20, { olfact = "zombie waltzers" })
	end

	function f.do_moxie_use_dancecard()
		if have("dance card") then
			local dance_card_turn = tonumber(ascension["dance card turn"]) or -1000
			if dance_card_turn < turnsthisrun() then
				return use_item("dance card")
			end
		end
	end

	function f.get_dinghy()
		inform "make dingy dinghy"
		if not have("dinghy plans") then
			inform "shore for dinghy plans"
			local function get_shore_trips()
				local pt, pturl = get_page("/shore.php")
				local trips = pt:match("You have taken (.-) trip")
				if trips == "no" then
					trips = 0
				elseif trips == "one" then
					trips = 1
				else
					trips = tonumber(trips)
				end
				return trips
			end
			local trips = get_shore_trips()
			local function do_trip(tripid)
				result, resulturl = post_page("/shore.php", { pwd = pwd, whichtrip = tripid })
				local new_trips = get_shore_trips()
				if new_trips > trips then
					did_action = true
				end
			end
			local shore_tower_items = {
				["stick of dynamite"] = 1,
				["tropical orchid"] = 2,
				["barbed-wire fence"] = 3,
			}

			local tbl = ascension["zone.lair.itemsneeded"] or {}
			local need_item = nil
			local want_adv = nil
			for from, to in pairs(tbl) do
				if shore_tower_items[to] then
					need_item = to
					want_adv = shore_tower_items[to]
				end
			end
			if not need_item then
				error "Don't know which shore tower item is needed."
			end
			if trips == 1 and not have(need_item) then
				do_trip(want_adv)
				did_action = false
				if have(need_item) then
					did_action = true
				end
			elseif trips >= 2 and trips < 5 and have(need_item) then
				local whichtrip = {
					["Muscle"] = 1,
					["Mysticality"] = 2,
					["Moxie"] = 3,
				}
				do_trip(whichtrip[get_mainstat()])
			end
		elseif not have("dingy planks") then
			inform "get dingy planks from hermit"
			f.ensure_worthless_item()
			buy_item("hermit permit", "m")
			result, resulturl = post_page("/hermit.php", { action = "trade", whichitem = get_itemid("dingy planks"), quantity = 1 })
			if have("dingy planks") then
				did_action = true
			else
				error "Failed to buy dingy planks"
			end
		else
			use_item("dinghy plans")
			if have("dingy dinghy") then
				did_action = true
			end
		end
	end

	function f.get_big_book_of_pirate_insults()
		if meat() < 1500 then
			error "Not enough meat for insult book + dictionary"
		elseif have("eyepatch") and have("swashbuckling pants") and have("stuffed shoulder parrot") and not have("The Big Book of Pirate Insults") then
			inform "buy insult book and dictionary"
			wear { hat = "eyepatch", pants = "swashbuckling pants", acc1 = "stuffed shoulder parrot" }
			buy_item("The Big Book of Pirate Insults", "r")
			buy_item("abridged dictionary", "r")
			if have("The Big Book of Pirate Insults") and have("abridged dictionary") then
				did_action = true
			end
		else
			go("get swashbuckling outfit", 66, macro_noodlecannon(), {}, { "Smooth Movements", "The Sonata of Sneakiness", "Fat Leon's Phat Loot Lyric" }, "Slimeling", 25, { choice_function = function (advtitle, choicenum)
				if advtitle == "Amatearrr Night" then
					if not have("stuffed shoulder parrot") then
						return "What's orange and sounds like a parrot?" -- stuffed shoulder parrot
					else
						return "What's gold and sounds like a pirate?" -- eyepatch
					end
				elseif advtitle == "The Arrrbitrator" then
					if not have("eyepatch") then
						return "Vote for Jack Robinson" -- eyepatch
					else
						return "Vote for Sergeant Hook" -- swashbuckling pants
					end
				elseif advtitle == "Barrie Me at Sea" then
					if not have("swashbuckling pants") then
						return "Help Captain Ladle" -- swashbuckling pants
					else
						return "Help Sammy Skillet" -- stuffed shoulder parrot
					end
				end
			end })
		end
		return result, resulturl, did_action
	end

	function f.do_8bit_realm()
		pixels = count("red pixel")
		if count("green pixel") < pixels then
			pixels = count("green pixel")
		end
		if count("blue pixel") < pixels then
			pixels = count("blue pixel")
		end
		pixels = pixels + count("white pixel")
		if pixels < 30 then
			if not have("continuum transfunctioner") then
				inform "pick up continuum transfunctioner"
				get_page("/mystic.php")
				post_page("/mystic.php", { action = "crackyes1" })
				post_page("/mystic.php", { action = "crackyes2" })
				result, resulturl = post_page("/mystic.php", { action = "crackyes3" })
				if have("continuum transfunctioner") then
					did_action = true
				end
			else
				go("farm pixels for digital key: " .. pixels, 73, macro_autoattack(), nil, {"Spirit of Garlic", "Fat Leon's Phat Loot Lyric"}, "Stocking Mimic", 15, { olfact = "Blooper", equipment = { acc1 = "continuum transfunctioner" } })
			end
		elseif count("white pixel") < 30 then
			inform "make white pixels"
			local to_make = 30 - count("white pixel")
			post_page("/mystic.php", { action = "makepixel", pwd = pwd, makewhich = get_itemid("white pixel"), quantity = to_make })
			if count("white pixel") >= 30 then
				did_action = true
			end
		else
			inform "make digital key"
			post_page("/mystic.php", { action = "makepixel", pwd = pwd, makewhich = get_itemid("digital key"), quantity = 1 })
			wear {} -- TODO: should not be necessary
			if have("digital key") and have_inventory("continuum transfunctioner") then
				did_action = true
			end
		end
	end

	function f.buy_use_chewing_gum()
		inform "use chewing gum"
		if not have("chewing gum on a string") then
			buy_item("chewing gum on a string", "m")
			if not have("chewing gum on a string") then
				error "Couldn't buy chewing gum"
			end
		end
		result, resulturl = use_item("chewing gum on a string")
		if result:match("You acquire") then
			did_action = true
		end
		return result, resulturl, did_action
	end

	function f.get_starting_items()
		if not ((have("stolen accordion") or have("Rock and Roll Legend")) and have("turtle totem") and have("saucepan")) then
			return f.buy_use_chewing_gum()
		end

		if not have("Rock and Roll Legend") then
			inform "pick up RnR"
			f.ensure_worthless_item()
			buy_item("hermit permit", "m")
			if not have("hot buttered roll") then
				result, resulturl = post_page("/hermit.php", { action = "trade", whichitem = get_itemid("hot buttered roll"), quantity = 1 })
			end
			if not have("hot buttered roll") then
				error "Failed to buy hot buttered roll"
			end
			if not have("casino pass") then
				result, resulturl = buy_item("casino pass", "m")
				if not have("casino pass") then
					error "Failed to buy casino pass"
				end
			end
			if not have("big rock") then
				f.trade_for_clover()
				if not have("ten-leaf clover") and have("disassembled clover") then
					result, resulturl = use_item("disassembled clover")
				end
				if not have("ten-leaf clover") then
					uncloset_itemid(get_itemid("ten-leaf clover"))
				end
				if not have("ten-leaf clover") then
					error "No ten-leaf clover"
				end
				ensure_buffs { "Mental A-cue-ity" }
				result, resulturl = get_page("/casino.php", { action = "slot", whichslot = "11" })
				if not have("big rock") then
					error "Didn't get big rock"
				end
			end
			result, resulturl = smith_items("hot buttered roll", "big rock")
			result, resulturl = smith_items("heart of rock and roll", "stolen accordion")
			if have("Rock and Roll Legend") then
				did_action = true
			end
			return result, resulturl, did_action
		end

		if not have("seal tooth") then
			inform "pick up seal tooth"
			f.ensure_worthless_item()
			buy_item("hermit permit", "m")
			result, resulturl = post_page("/hermit.php", { action = "trade", whichitem = get_itemid("seal tooth"), quantity = 1 })
			if have("seal tooth") then
				did_action = true
			else
				error "Failed to buy seal tooth"
			end
			return result, resulturl, did_action
		end
	end

	function f.do_starting_stuff(council_text)
		if not have("Clan VIP Lounge key") then
			inform "pulling VIP key"
			freepull_itemid(get_itemid("Clan VIP Lounge key"))
			get_page("/clan_viplounge.php", { action = "lookingglass" })
			get_page("/clan_viplounge.php", { action = "klaw" })
			get_page("/clan_viplounge.php", { action = "klaw" })
			get_page("/clan_viplounge.php", { action = "klaw" })
			if have("Clan VIP Lounge key") then
				did_action = true
			end
		elseif council_text:contains("visit the Toot Oriole") then
			inform "doing toot quest"
			get_page("/guild.php", { place = "challenge" })
			get_page("/tutorial.php", { action = "toot" })
			use_item("Newbiesport&trade; tent")
			use_item("letter from King Ralph XI")
			use_item("pork elf goodies sack")

			ensure_mp(6)
			cast_buff(8002, 3) -- summon sugar sheet
			get_page("/sugarsheets.php", { pwd = pwd, action = "fold", whichitem = get_itemid("sugar shield") })
			get_page("/sugarsheets.php", { pwd = pwd, action = "fold", whichitem = get_itemid("sugar chapeau") })
			if not have("astral shirt") then
				get_page("/sugarsheets.php", { pwd = pwd, action = "fold", whichitem = get_itemid("sugar shirt") })
			end

			wear {} -- TODO: should not be necessary

			get_page("/campground.php")
			get_page("/campground.php", { action = "garden", pwd = pwd })

			post_page("/campground.php", { action = "telescopelow" })

	-- 		post_page("/campground.php", { smashstone = "Yep.", pwd = pwd, confirm = "on" })

			did_action = true
		elseif meat() < 5000 and (have("baconstone") or have("hamethyst") or have("porquoise")) then
			inform "selling pork gems"
			if count("baconstone") > 10 or count("hamethyst") > 10 or count("porquoise") > 10 then
				error "we somehow have lots of pork gems"
			else
				sell_itemid(get_itemid("baconstone"), count("baconstone"))
				sell_itemid(get_itemid("hamethyst"), count("hamethyst"))
				sell_itemid(get_itemid("porquoise"), count("porquoise"))
				buy_item("detuned radio", "5")
				set_mcd(10)
				did_action = true
			end
		end
		return result, resulturl, did_action
	end

	function f.do_strange_leaflet()
		inform "doing strange leaflet"
		local function do_leaflet() -- TODO: merge, copypasted from leaflet.lua
			local function pp(cmds)
				local t = nil
				for _, c in pairs(cmds) do
					t = post_page("/leaflet.php", { pwd = pwd, command = c })
				end
				return t
			end
			pp { "open door", "east", "take sword", "look at tinder", "take parchment" }
			local manteltext, manteluri = pp { "look at mantel" }
			local magic_words = {
				["small brick building"] = "plugh",
				["model ship inside a bottle"] = "yoho",
				["carved driftwood bird"] = "plover",
				["small white house"] = "xyzzy",
			}
			local magic = nil
			for a,b in pairs(magic_words) do
				if manteltext:match(a) then
					magic = b
				end
			end
			if magic == nil then
				text = manteltext
			else
				print("the magic word is", magic)
				pp { magic }
				pp { "west", "north", "take stick", "cut hedge", "west", "light stick", "east" }

				pp { "north", "kill snake", "open chest", "look behind chest", "look in hole", "south", "south" }

				pp { "east", "light fire", "take boots", "wear boots", "west" }

				pp { "south", "south" }
				pp { "south", "south" }

				print("exploring maze")
				for i = 1, 10 do
					pp { "north", "west", "east", "south" }
				end

				print("finishing leaflet")
				pp { "up", "take egg", "throw egg at roadrunner", "down" }
				pp { "move leaves", "up", "throw ruby at bowl" }
				pp { "gnusto cleesh", "up", "cleesh giant", "take ring", "win game" }
				text = pp { "exit" }

				print("leaflet done")
				text = [[<script type="text/javascript">top.charpane.location.href="charpane.php";</script>]] .. text
			end
		end
		use_item("strange leaflet")
		do_leaflet()
		if have("grue egg") then
			did_action = true
		end
		return result, resulturl, did_action
	end

	function f.unlock_hidden_temple()
		-- spooky forest
		if have("Spooky Temple map") and have("Spooky-Gro fertilizer") and have("spooky sapling") then
			inform "use spooky temple map"
			use_item("Spooky Temple map")
			local newwoodspt = get_page("/woods.php")
			if newwoodspt:contains("The Hidden Temple") then
				did_action = true
			end
		else
			if meat() < 100 then
				error "Not enough meat for spooky sapling"
			end
			go("get parts to unlock hidden temple", 15, macro_stasis(), {}, { "Smooth Movements", "The Sonata of Sneakiness" }, "Rogue Program", 10, { choice_function = function (advtitle, choicenum)
				if advtitle == "Arboreal Respite" then
					if not have("Spooky Temple map") then
						if not have("tree-holed coin") then
							return "Explore the stream"
						else
							return "Brave the dark thicket"
						end
					elseif not have("Spooky-Gro fertilizer") then
						return "Brave the dark thicket"
					elseif not have("spooky sapling") then
						return "Follow the old road"
					end
				elseif advtitle == "Consciousness of a Stream" then
					if not have("Spooky Temple map") and not have("tree-holed coin") then
						inform "get coin"
						return "Squeeze into the cave"
					end
				elseif advtitle == "Through Thicket and Thinnet" then
					if not have("Spooky Temple map") then
						return "Follow the coin"
					elseif not have("Spooky-Gro fertilizer") then
						inform "get fertilizer"
						return "Investigate the dense foliage"
					end
				elseif advtitle == "O Lith, Mon" then
					inform "get map"
					return "Insert coin to continue"
				elseif advtitle == "The Road Less Traveled" then
					if not have("spooky sapling") then
						return "Talk to the hunter"
					end
				elseif advtitle == "Tree's Last Stand" then
					if not have("spooky sapling") then
						inform "buying sapling"
						return "Buy a tree for 100 Meat"
					else
						return "Take your leave"
					end
				end
			end })
-- BUG: reads adventure title as Results. temp. workaround.
-- noncombat: {Results:} (504)
-- fallback for	Results:	504
			if not did_action and have("spooky sapling") and result:contains("Results:") then
				result, resulturl = post_page("/choice.php", { pwd = pwd, whichchoice = 504, option = 4 })
				result, resulturl, advagain = handle_adventure_result(result, resulturl, 15, nil, {})
				did_action = advagain
			end
		end
		return result, resulturl, did_action
	end

	function f.knob_goblin_king_with_cake(killmacro)
		if have("Knob cake") then
			inform "fight king in guard outfit"
			wear { hat = "Knob Goblin elite helm", weapon = "Knob Goblin elite polearm", pants = "Knob Goblin elite pants" }
			ensure_buffs { "Springy Fusilli", "Spirit of Garlic" }
			ensure_mp(40)
			fam "Frumious Bandersnatch"
			set_mcd(7) -- TODO: moxie-specific
			local pt, url = get_page("/cobbsknob.php", { action = "throneroom" })
			result, resulturl, advagain = handle_adventure_result(pt, url, "?", killmacro)
			-- TODO: auto-do these always
			set_mcd(10)
			wear {}
			did_action = advagain
		elseif have("unfrosted Knob cake") and have("Knob frosting") then
			inform "frost cake"
			result, resulturl = cook_items("unfrosted Knob cake", "Knob frosting")
			if have("Knob cake") then
				did_action = true
			end
		elseif have("Knob cake pan") and have("Knob batter") then
			inform "make unfrosted knob cake"
			result, resulturl = cook_items("Knob cake pan", "Knob batter")
			if have("unfrosted Knob cake") then
				did_action = true
			end
		else
			inform "get cake bits in guard outfit"
			wear { hat = "Knob Goblin elite helm", weapon = "Knob Goblin elite polearm", pants = "Knob Goblin elite pants" }
			result, resulturl, advagain = autoadventure(258)
			did_action = advagain
			if result:contains("it's a key") and result:contains("Knob lab key") then
				did_action = true
			end
			wear {}
		end
		return result, resulturl, did_action
	end

	function f.open_myst_guildstore()
		inform "unlock myst guild store"
		if meat() < 200 then
			error "Not enough meat for buying mmj at guild store"
		end
		get_page("/guild.php", { place = "challenge" })
		buy_item("magical mystery juice", "2")
		if have("magical mystery juice") then
			did_action = true
		else
			go("do myst guild quest", 113, macro_stasis(), {
				["A Sandwich Appears!"] = "sudo exorcise me a sandwich",
				["Oh No, Hobo"] = "Give him a beating",
				["Trespasser"] = "Tackle him",
				["The Singing Tree"] = "&quot;No singing, thanks.&quot;",
				["The Baker's Dilemma"] = "&quot;Sorry, I'm busy right now.&quot;",
			}, {}, "Mini-Hipster", 15)
		end
	end

	function f.unlock_guild_and_get_tonic_water()
		get_page("/guild.php", { place = "challenge" })
		local guildpt = get_page("/guild.php")
		if guildpt:match("scg") then
			inform "get tonic water"
			if challenge ~= "fist" then
				buy_item("soda water", "m", 10)
				post_page("/guild.php", { action = "stillfruit", whichitem = get_itemid("soda water"), quantity = 10 })
			else
				buy_item("soda water", "m", 1)
				post_page("/guild.php", { action = "stillfruit", whichitem = get_itemid("soda water"), quantity = 1 })
			end
			if have("tonic water") then
				did_action = true
			end
		else
			if not quest("Suffering For His Art") then
				get_page("/town_wrong.php", { place = "artist" })
				post_page("/town_wrong.php", { place = "artist", getquest = 1 })
			end
			go("do mox guild quest", 112, macro_stasis(), {
				["Now's Your Pants!  I Mean... Your Chance!"] = "Yoink!",
				["Aww, Craps"] = "Walk away",
				["Dumpster Diving"] = "Punch the hobo",
				["The Entertainer"] = "Introduce them to avant-garde",
				["Under the Knife"] = "Umm, no thanks. Seriously.",
				["Please, Hammer"] = "Sorry, no time.",
			}, {}, "Mini-Hipster", 15)
		end
	end

	function f.do_rqg()
		inform "doing red queen's garden"
		if buff("Down the Rabbit Hole") then
			print("red/yellow raying in garden")
			fam "He-Boulder"
			if not buff("Everything Looks Red") then
				ensure_buffs { "Leash of Linguini" }
				wear { familiarequip = "sugar shield" }
			else
				wear {}
			end
			f.heal_up()
			ensure_mp(7)
			local want_monstername = "XXXnothingXXX"
			local call_redray_line = ""
			if not buff("Everything Looks Yellow") then
				local want_monster_tbl = {
					Muscle = "Tiger-lily",
					Mysticality = "wasp",
					Moxie = "snapdragon",
				}
				want_monstername = want_monster_tbl[get_mainstat()]
			end
			if not buff("Everything Looks Red") then
				call_redray_line = [[call do_redray
goto m_done
]]
			end
-- TODO: hacked in suckerpunch/sing, fix
			local macro_garden = [[
abort pastround 20
abort hppercentbelow 50
scrollwhendone

sub stall
  if hppercentbelow 75
	cast saucy salve
	goto do_return
  endif
  if hasskill Static Shock
	cast Static Shock
	goto do_return
  endif
  if hascombatitem seal tooth
	use seal tooth
	goto do_return
  endif
  if hascombatitem spices
	use spices
	goto do_return
  endif
  if hasskill suckerpunch
    cast suckerpunch
	goto do_return
  endif
  cast sing
  mark do_return
endsub

sub do_yellowray
  while !times 15
	if match "yellow eye"
	  cast Point at your opponent
	  goto yellowray_done
	endif
	call stall
  endwhile
  mark yellowray_done
endsub

sub do_redray
  while !times 15
	if match "red eye"
	  cast Point at your opponent
	  goto redray_done
	endif
	call stall
  endwhile
  mark redray_done
endsub

sub do_killgarden
  while !times 15
	if match "red eye"
	  if hasskill Point at your opponent
	    cast Point at your opponent
	  endif
	endif
	cast Cannelloni Cannon
  endwhile
endsub

cast Entangling Noodles

if monstername ]] .. want_monstername .. [[

  call do_yellowray
  goto m_done
endif

]] .. call_redray_line .. [[


call do_killgarden

mark m_done

]]
			result, resulturl, advagain = autoadventure(225, macro_garden)
			unequip_slot("familiarequip")
			did_action = advagain
		elseif have("&quot;DRINK ME&quot; potion") then
			if challenge == "fist" then
				use_item("&quot;DRINK ME&quot; potion")
				if buff("Down the Rabbit Hole") then
					did_action = true
				end
			else
				inform "using drink me pot, getting cat-alyzed"
				if not have("snorkel") then
					buy_item("snorkel", "z")
				end
				wear { hat = "snorkel" }
				use_item("&quot;DRINK ME&quot; potion")
				get_page("/rabbithole.php", { action = "teaparty" })
				-- TODO: do with handle_result
				post_page("/choice.php", { pwd = pwd, whichchoice = "441", option = "1" }) -- get snorkel hatter buff
				if buff("Cat-Alyzed") then
					did_action = true
				end
			end
		else
			error "Unable to enter RQG"
		end
		return result, resulturl, did_action
	end

	function f.make_star_key()
		local got_enough = false
		if count("star chart") >= 3 or (challenge == "fist" and count("star chart") >= 2) then
			if count("star") >= 8+5 and count("line") >= 7+3 then
				sparestars = count("star") - 8 - 5
				sparelines = count("line") - 7 - 3
				if sparestars >= 5 and sparelines >= 6 then
					got_enough = true
				elseif sparestars >= 6 and sparelines >= 5 then
					got_enough = true
				elseif sparestars >= 7 and sparelines >= 4 then
					got_enough = true
				elseif challenge == "fist" then
					got_enough = true
				end
			end
		end
		if got_enough then
			inform "make star stuff"
			if not have("Richard's star key") then
				post_page("/starchart.php", { action = "makesomething", pwd = pwd, numstars = "8", numlines = "7" })
			end
			if not have("star hat") then
				post_page("/starchart.php", { action = "makesomething", pwd = pwd, numstars = "5", numlines = "3" })
			end
			if not have("star crossbow") and not have("star staff") and not have("star sword") and challenge ~= "fist" then
				if count("star") >= 5 and count("line") >= 6 then
					post_page("/starchart.php", { action = "makesomething", pwd = pwd, numstars = "5", numlines = "6" })
				elseif count("star") >= 6 and count("line") >= 5 then
					post_page("/starchart.php", { action = "makesomething", pwd = pwd, numstars = "6", numlines = "5" })
				elseif count("star") >= 7 and count("line") >= 4 then
					post_page("/starchart.php", { action = "makesomething", pwd = pwd, numstars = "7", numlines = "4" })
				end
			end
			if have("Richard's star key") and have("star hat") and (have("star crossbow") or have("star staff") or have("star sword") or challenge == "fist") then
				did_action = true
			end
		else
			if trailed and trailed == "Astronomer" then
				error("Trailing " .. trailed .. " when finishing hits")
			end
			go("finish hits", 83, macro_noodlecannon(), {}, { "Spirit of Peppermint", "Fat Leon's Phat Loot Lyric", "Heavy Petting", "Peeled Eyeballs", "Leash of Linguini", "Empathy" }, "Slimeling", 40)
		end
		return result, resulturl, did_action
	end

	function f.do_tavern()
		if quest_text("You should head back to Bart") then
			result, resulturl = get_page("/tavern.php", { place = "barkeep" })
			if have("Typical Tavern swill") then
				did_action = true
			end
		elseif quest_text("Bart Ender wants you to head down") then
-- 			inform "do rat cellar"
			cellarpt = get_page("/cellar.php")
			local function explore()
				tiles = { 4, 3, 2, 1, 6, 11, 16, 17, 21, 22 }
				for _, x in pairs(tiles) do
					if cellarpt:contains("whichspot=" .. x .. ">") then
						inform("exploring rat cellar tile " .. x)
						return get_page("/cellar.php", { action = "explore", whichspot = x })
					end
				end
				error "No suitable tile found"
			end
			fam "Rogue Program"
			f.heal_up()
			f.burn_mp(20)
			ensure_mp(5)
			local pt, url = explore()
			-- TODO: handle barrels better?
			result, resulturl, advagain = handle_adventure_result(pt, url, "?", macro_stasis(), {
				["1984 Had Nothing on This Cellar"] = "Dump out the crate",
				["A Rat's Home..."] = "Kick over the castle",
				["Crate Expectations"] = "Smash the crates",
				["Staring Down the Barrel"] = "Smash the barrel",
				["Those Who Came Before You"] = "Search the body",
				["Of Course!"] = "Turn off the faucet",
			})
			did_action = advagain
			if result:contains("You close the valve") or result:contains("Go back to the Typical Tavern Cellar") then
				did_action = true
			end
		else
			inform "do guild, talk to bartender"
--~ 				local guildpt = get_page("/guild.php", { guild = "t" })
			local guildpt = get_page("/guild.php")
			get_page("/guild.php", { place = "ocg" })
			get_page("/guild.php", { place = "ocg" })
			get_page("/guild.php", { place = "scg" })
			get_page("/guild.php", { place = "scg" })
-- 				The Council says that the owner of the Typical Tavern, in the Distant Woods, is having some problems.
			local pt = get_page("/tavern.php", { place = "susguy" })
			if pt:contains("First bottle's free") and pt:contains("for free!") then
				local m = meat()
				post_page("/tavern.php", { action = "buygoofballs" })
				if not have("goofballs") or meat() ~= m then
					error "Error getting free goofballs"
				end
			end
			result, resulturl = get_page("/tavern.php", { place = "barkeep" })
			refresh_quest()
			if quest_text("Bart Ender wants you to head down") then
				did_action = true
			end
		end
		return result, resulturl, did_action
	end

	function f.do_sewerlevel()
		if advs() < 12 then
			error("less than 12 advs for sewerleveling")
		elseif drunkenness() < 3 then
			error("no liver used when sewerleveling")
		elseif not buff("Pisces in the Skyces") then
			error "No gamestore +spelldmg% buff for sewer-leveling"
		else
			maybe_ensure_buffs { "Mental A-cue-ity" }
			go("fight in sewer", 166, macro_noodlegeyser(3), {
				["Disgustin' Junction"] = "Swim back toward the entrance",
				["The Former or the Ladder"] = "Play in the water",
				["Somewhat Higher and Mostly Dry"] = "Dive back into the water",
			}, { "Springy Fusilli", "Spirit of Garlic", "Jaba&ntilde;ero Saucesphere", "Curiosity of Br'er Tarrypin" }, "Frumious Bandersnatch", 50, { equipment = { hat = "sugar chapeau" } })
			if did_action then
				wear {}
			end
		end
		return result, resulturl, did_action
	end

	function f.do_azazel()
		if not have("Azazel's lollipop") then
			if count("imp air") >= 5 and have("observational glasses") then
				inform("solve mourn")
				if challenge ~= "fist" then
					wear { weapon = "hilarious comedy prop", offhand = "Victor, the Insult Comic Hellhound Puppet" }
					result, resulturl = post_page("/pandamonium.php", { action = "mourn", preaction = "prop" })
					result, resulturl = post_page("/pandamonium.php", { action = "mourn", preaction = "insult" })
				end
				wear { acc1 = "observational glasses" }
				if not have_inventory("hilarious comedy prop") or not have_inventory("Victor, the Insult Comic Hellhound Puppet") then
					error "Somehow didn't have items for Mourn!"
				end
				result, resulturl = post_page("/pandamonium.php", { action = "mourn", preaction = "observe" })
				if have("Azazel's lollipop") then
					did_action = true
				end
			else
				local macro_laughfloor = [[
if monstername imp
]] .. macro_ppnoodlecannon() .. [[

  goto m_done
endif

]] .. macro_noodleserpent() .. [[

mark m_done

]]
				if challenge == "fist" then
					macro_laughfloor = macro_fist()
				end
				if count("imp air") < 5 then
					go("mourn, imp air: " .. count("imp air"), 242, macro_laughfloor, nil, { "Leash of Linguini", "Empathy", "Spirit of Garlic", "Fat Leon's Phat Loot Lyric", "A Few Extra Pounds" }, "Slimeling", 35)
				else
					go("mourn, imp air: " .. count("imp air"), 242, macro_laughfloor, nil, { "Leash of Linguini", "Empathy", "Spirit of Garlic", "A Few Extra Pounds" }, "Rogue Program", 35)
				end
			end
		elseif not have("Azazel's unicorn") then
			if count("bus pass") >= 5 and (count("sponge cake") + count("comfy pillow") + count("booze-soaked cherry")) >= 2 and (count("gin-soaked blotter paper") + count("giant marshmallow") + count("beer-scented teddy bear")) >= 2 then
				inform("solve sven golly")
				local bognort = have("giant marshmallow") and "giant marshmallow" or "gin-soaked blotter paper"
				local stinkface = have("beer-scented teddy bear") and "beer-scented teddy bear" or "gin-soaked blotter paper"
				local flargwurm = have("booze-soaked cherry") and "booze-soaked cherry" or "sponge cake"
				local jim = have("comfy pillow") and "comfy pillow" or "sponge cake"
				result, resulturl = post_page("/pandamonium.php", { action = "sven", preaction = "help" })
				result, resulturl = post_page("/pandamonium.php", { action = "sven", bandmember = "Bognort", togive = get_itemid(bognort), preaction = "try" })
				result, resulturl = post_page("/pandamonium.php", { action = "sven", bandmember = "Stinkface", togive = get_itemid(stinkface), preaction = "try" })
				result, resulturl = post_page("/pandamonium.php", { action = "sven", bandmember = "Flargwurm", togive = get_itemid(flargwurm), preaction = "try" })
				result, resulturl = post_page("/pandamonium.php", { action = "sven", bandmember = "Jim", togive = get_itemid(jim), preaction = "try" })
				if have("Azazel's unicorn") then
					did_action = true
				end
			else
				if count("bus pass") < 5 then
					go("sven golly, bus passes: " .. count("bus pass"), 243, macro_noodlecannon(), nil, { "Leash of Linguini", "Empathy", "Spirit of Garlic", "Fat Leon's Phat Loot Lyric", "A Few Extra Pounds" }, "Slimeling", 20)
				else
					go("sven golly, bus passes: " .. count("bus pass"), 243, macro_noodlecannon(), nil, { "Leash of Linguini", "Empathy", "Spirit of Garlic", "A Few Extra Pounds" }, "Rogue Program", 20)
				end
			end
		elseif not have("Azazel's tutu") then
			inform "solve stranger"
			result, resulturl = get_page("/pandamonium.php", { action = "moan" })
			result, resulturl = get_page("/pandamonium.php", { action = "moan" })
			if have("Azazel's tutu") then
				did_action = true
			end
		else
			inform "solve azazel"
			result, resulturl = get_page("/pandamonium.php", { action = "temp" })
			if have("steel margarita") then
				did_action = true
			end
		end
		return result, resulturl, did_action
	end

	function f.do_boss_bat()
		local batholept = get_page("/bathole.php")
		if not batholept:match("Boss") then
			if have("sonar-in-a-biscuit") then
				use_item("sonar-in-a-biscuit")
				did_action = true
			elseif not batholept:match("Beanbat") then
				if not have("ten-leaf clover") then
					use_item("disassembled clover")
				end
				if have("ten-leaf clover") then
					go("clovering sonars", 31, nil, nil, {}, "Slimeling", 10)
				end
				if count("sonar-in-a-biscuit") == 2 then
					did_action = true
				end
			elseif have("enchanted bean") then
				go("getting sonars", 32, macro_autoattack(), nil, { "Leash of Linguini", "Empathy", "Fat Leon's Phat Loot Lyric", "Butt-Rock Hair" }, "Slimeling", 10)
			else
				go("getting sonars / enchanted bean", 33, macro_autoattack(), nil, { "Leash of Linguini", "Empathy", "Fat Leon's Phat Loot Lyric", "Butt-Rock Hair" }, "Slimeling", 10)
			end
		else
			if not ascension["__script.boss bat turns"] then
				ascension["__script.boss bat turns"] = 0
			end
			set_mcd(4) -- TODO: moxie-specific
			local played = tonumber(ascension["__script.boss bat turns"])
			ascension["__script.boss bat turns"] = played + 1
			if played < 4 then
				go("killing boss bat guardians", 34, macro_noodlecannon(), nil, { "Leash of Linguini", "Empathy", "Polka of Plenty" }, "Hobo Monkey", 25)
			else
				go("killing boss bat", 34, macro_noodlecannon(), nil, { "Leash of Linguini", "Empathy", "Polka of Plenty" }, "Knob Goblin Organ Grinder", 25)
			end
			set_mcd(10)
		end
		return result, resulturl, did_action
	end

	function f.make_meatcar()
		if not have("Degrassi Knoll shopping list") then
			inform "get shopping list"
			get_page("/guild.php", { place = "paco" })
			if have("Degrassi Knoll shopping list") then
				did_action = true
			else
				post_page("/guild.php", { action = "chal" })
				get_page("/guild.php", { place = "paco" })
				if have("Degrassi Knoll shopping list") then
					did_action = true
				end
			end
		else
			inform "build meatcar"
			if not have("meat stack") then
				get_page("/inventory.php", { quantity = 1, action = "makestuff", pwd = pwd, whichitem = get_itemid("meat stack"), ajax = 1 })
			end
			buy_item("cog", "5")
			buy_item("empty meat tank", "5")
			buy_item("tires", "5")
			buy_item("spring", "5")
			buy_item("sprocket", "5")
			f.ensure_worthless_item()
			buy_item("hermit permit", "m")
			post_page("/hermit.php", { action = "trade", whichitem = get_itemid("sweet rims"), quantity = 1 })
			meatpaste_items("empty meat tank", "meat stack")
			meatpaste_items("spring", "sprocket")
			meatpaste_items("sprocket assembly", "cog")
			meatpaste_items("cog and sprocket assembly", "full meat tank")
			meatpaste_items("tires", "sweet rims")
			meatpaste_items("meat engine", "dope wheels")
			if not have("bitchin' meatcar") then
				error("Failed to build bitchin' meatcar")
			end
			inform "unlock beach"
			get_page("/forestvillage.php", { place = "untinker" })
			post_page("/forestvillage.php", { action = "screwquest" })
			get_page("/knoll.php", { place = "smith" })
			get_page("/forestvillage.php", { place = "untinker" })
			result, resulturl = get_page("/guild.php", { place = "paco" }) -- TODO: need the topmenu refreshed from this
			use_item("Degrassi Knoll shopping list")
			b = get_page("/beach.php")
			if b:match("shore.php") then
				did_action = true
			end
		end
		return result, resulturl, did_action
	end

	function f.do_crypt()
		local cyrpt = get_page("/cyrpt.php")
		if have("skeleton bone") and have("loose teeth") then
			meatpaste_items("skeleton bone", "loose teeth")
		end
		if have("evil eye") then
			use_item("evil eye")
		end
		local noncombattbl = {}
		if get_mainstat() == "Muscle" then
			noncombattbl["Turn Your Head and Coffin"] = "Investigate the fancy coffin"
			noncombattbl["Skull, Skull, Skull"] = "Leave the skulls alone"
			noncombattbl["Urning Your Keep"] = "Turn away"
			noncombattbl["Death Rattlin'"] = "Open the rattling one"
		elseif get_mainstat() == "Mysticality" then
			noncombattbl["Turn Your Head and Coffin"] = "Leave them all be"
			noncombattbl["Skull, Skull, Skull"] = "Leave the skulls alone"
			noncombattbl["Urning Your Keep"] = "Investigate the first urn"
			noncombattbl["Death Rattlin'"] = "Open the rattling one"
		elseif get_mainstat() == "Moxie" then
			noncombattbl["Turn Your Head and Coffin"] = "Leave them all be"
			noncombattbl["Skull, Skull, Skull"] = "Check behind the first one"
			noncombattbl["Urning Your Keep"] = "Turn away"
			noncombattbl["Death Rattlin'"] = "Open the rattling one"
		end
		if challenge == "fist" then
			noncombattbl["Turn Your Head and Coffin"] = "Check out the pine box"
			noncombattbl["Skull, Skull, Skull"] = "Look inside the second one"
			noncombattbl["Urning Your Keep"] = "See what's behind Urn #3"
			ensure_buffs { "Smooth Movements" }
		end
		if cyrpt:match("Defiled Alcove") then
			-- TODO: hustlin pool buff?
			-- TODO: cletus +init?
			-- TODO: heart of yellow?
			maybe_ensure_buffs { "Sugar Rush" }
			go("do crypt alcove", 261, macro_stasis(), noncombattbl, { "Butt-Rock Hair", "Smooth Movements", "The Sonata of Sneakiness", "Fat Leon's Phat Loot Lyric", "A Few Extra Pounds", "Springy Fusilli" }, "Rogue Program", 15)
		elseif cyrpt:match("Defiled Cranny") then
			maybe_ensure_buffs { "Mental A-cue-ity" }
			go("do crypt cranny", 262, macro_noodlecannon(), noncombattbl, { "Spirit of Garlic", "Butt-Rock Hair", "Smooth Movements", "The Sonata of Sneakiness", "Fat Leon's Phat Loot Lyric", "A Few Extra Pounds", "Ur-Kel's Aria of Annoyance" }, "Baby Bugged Bugbear", 35)
		elseif cyrpt:match("Defiled Niche") then
			go("do crypt niche", 263, make_cannonsniff_macro("dirty old lihc"), noncombattbl, { "Spirit of Garlic", "Butt-Rock Hair", "Fat Leon's Phat Loot Lyric", "A Few Extra Pounds" }, "Rogue Program", 25, { olfact = "dirty old lihc" })
		elseif cyrpt:match("Defiled Nook") then
			go("do crypt nook", 264, macro_noodlecannon(), noncombattbl, { "Butt-Rock Hair", "Fat Leon's Phat Loot Lyric", "A Few Extra Pounds", "Heavy Petting", "Peeled Eyeballs", "Leash of Linguini", "Empathy" }, "Slimeling", 15)
		else
			inform "kill bonerdagon"
			if challenge == "fist" then
				error "TODO: Kill bonerdagon in fist"
			end
			ensure_buffs { "A Few Extra Pounds", "Jalape&ntilde;o Saucesphere", "Jaba&ntilde;ero Saucesphere", "Springy Fusilli", "Spirit of Garlic" }
			fam "Knob Goblin Organ Grinder"
			f.heal_up()
			ensure_mp(50)
			local pt, url = get_page("/crypt.php", { action = "heart" })
			result, resulturl, advagain = handle_adventure_result(pt, url, "?", macro_noodlegeyser(7), { ["The Haert of Darkness"] = "When I...  Yes?" })
			if advagain then
				did_action = true
			end
		end
		return result, resulturl, did_action
	end

	function f.get_ballroom_key()
		local manor = get_page("/manor.php")
		if not manor:match("Stairs Up") then
			go("unlock upstairs", 104, macro_stasis(), {}, {"Smooth Movements", "The Sonata of Sneakiness", "Butt-Rock Hair", "A Few Extra Pounds"}, "Rogue Program", 5, { choice_function = function (advtitle, choicenum)
				if advtitle == "Take a Look, it's in a Book!" then
					return "", 99
				end
			end})
		else
			local toequip = {}
			if get_mainstat() == "Muscle" then
				if have("Crown of the Goblin King") then
					toequip = { hat = "Crown of the Goblin King" }
				end
				wear(toequip)
				if buffedmainstat() < 85 then
					ensure_buffs{"Go Get 'Em, Tiger!"}
				end
			elseif get_mainstat() == "Mysticality" then
				wear {}
				if buffedmainstat() < 85 then
					ensure_buffs { "The Magical Mojomuscular Melody", "The Sonata of Sneakiness" } -- HACK: sonata is there to avoid shrugging that
				end
				if buffedmainstat() < 85 then
					ensure_buffs{"Glittering Eyelashes"}
				end
				if buffedmainstat() < 85 and not buff("Smoky Third Eye") and not buff("Down the Rabbit Hole") and have("&quot;DRINK ME&quot; potion") then
					if not have("ravioli hat") then
						return f.buy_use_chewing_gum()
					end
					use_item("&quot;DRINK ME&quot; potion")
					wear { hat = "ravioli hat" }
					get_page("/rabbithole.php", { action = "teaparty" })
					post_page("/choice.php", { pwd = pwd, whichchoice = "441", option = "1" }) -- get hatter buff
					wear {}
				end
			elseif get_mainstat() == "Moxie" then
				wear {}
				if buffedmainstat() < 85 then
					ensure_buffs { "The Moxious Madrigal", "The Sonata of Sneakiness" } -- HACK: sonata is there to avoid shrugging that
				end
				if buffedmainstat() < 85 then
					ensure_buffs { "Butt-Rock Hair" }
				end
				if buffedmainstat() < 85 and not buff("Cat-Alyzed") and not buff("Down the Rabbit Hole") and have("&quot;DRINK ME&quot; potion") then
					use_item("&quot;DRINK ME&quot; potion")
					wear { hat = "snorkel" }
					get_page("/rabbithole.php", { action = "teaparty" })
					post_page("/choice.php", { pwd = pwd, whichchoice = "441", option = "1" }) -- get hatter buff
					wear {}
				end
			end
			if buffedmainstat() < 85 and not buff("Starry-Eyed") then
				local gazept = post_page("/campground.php", { action = "telescopehigh" })
			end
			if buffedmainstat() < 85 then
				error("Can't enter bedroom")
			end
			maybe_ensure_buffs { "Mental A-cue-ity" }
			local macro = macro_noodlegeyser(4)
			if challenge == "fist" then
				macro = macro_fist()
			end
			go("do bedroom", 108, macro, {}, { "Smooth Movements", "The Sonata of Sneakiness", "Springy Fusilli", "Spirit of Garlic", "Jaba&ntilde;ero Saucesphere", "Jalape&ntilde;o Saucesphere" }, "Frumious Bandersnatch", 50, { choice_function = function (advtitle, choicenum)
				if choicenum == 82 then
					return "Kick it and see what happens"
				elseif choicenum == 83 then
					return "Check the bottom drawer"
				elseif choicenum == 84 then
					if have("Lord Spookyraven's spectacles") then
						return "Open the bottom drawer"
					else
						return "Look behind the nightstand"
					end
				elseif choicenum == 85 then
					print("bedroom key adventure", ascension["zone.manor.unlocked ballroom key"], ascension["scriptcheck.done ballroom key"])
					if not ascension["zone.manor.unlocked ballroom key"] and not ascension["scriptcheck.done ballroom key"] then
						ascension["scriptcheck.done ballroom key"] = "yes"
						return "Check the top drawer"
					else
						return "Check the bottom drawer"
					end
				end
			end, equipment = toequip })
		end
		return result, resulturl, did_action
	end

	function f.do_friars()
-- 		TODO: more buffs?
		if challenge == "fist" then
			maybe_ensure_buffs { "Mental A-cue-ity" }
		end
		if count("hellion cube") < 2 then
			go("get dodecagram", 239, make_cannonsniff_macro("Hellion"), nil, { "Smooth Movements", "The Sonata of Sneakiness", "Astral Shell", "Ghostly Shell", "Leash of Linguini", "Empathy", "Butt-Rock Hair", "Spirit of Garlic", "Fat Leon's Phat Loot Lyric", "A Few Extra Pounds" }, "Slimeling", 20, { olfact = "Hellion" })
		elseif (count("hot wing") < 3 or (meat() < 1000 and fullness() < 5)) and not have("box of birthday candles") then
			go("get hot wings", 238, macro_noodlecannon(), nil, { "Smooth Movements", "The Sonata of Sneakiness", "Astral Shell", "Ghostly Shell", "Leash of Linguini", "Empathy", "Butt-Rock Hair", "A Few Extra Pounds" }, "Slimeling", 20)
		elseif not have("dodecagram") then
			go("get dodecagram", 239, make_cannonsniff_macro("Hellion"), nil, { "Smooth Movements", "The Sonata of Sneakiness", "Astral Shell", "Ghostly Shell", "Leash of Linguini", "Empathy", "Butt-Rock Hair", "Spirit of Garlic", "Fat Leon's Phat Loot Lyric", "A Few Extra Pounds" }, "Slimeling", 20, { olfact = "Hellion" })
		elseif not have("ruby W") or have_reagent_pastas < 4 and (have_reagent_pastas < 8 or trailed ~= "Hellion") then
			go("get ruby W / hellion cubes", 239, make_cannonsniff_macro("Hellion"), nil, { "Astral Shell", "Ghostly Shell", "Leash of Linguini", "Empathy", "Butt-Rock Hair", "Spirit of Garlic", "Fat Leon's Phat Loot Lyric", "A Few Extra Pounds" }, "Slimeling", 20, { olfact = "Hellion" })
		elseif count("hot wing") < 3 then
			go("get hot wings", 238, macro_noodlecannon(), nil, { "Smooth Movements", "The Sonata of Sneakiness", "Astral Shell", "Ghostly Shell", "Leash of Linguini", "Empathy", "Butt-Rock Hair", "A Few Extra Pounds" }, "Slimeling", 20)
		elseif not have("box of birthday candles") then
			go("get candles", 238, macro_stasis(), nil, { "Smooth Movements", "The Sonata of Sneakiness", "Astral Shell", "Ghostly Shell", "Leash of Linguini", "Empathy", "Butt-Rock Hair", "A Few Extra Pounds" }, "Rogue Program", 15)
		elseif not have("eldritch butterknife") then
			go("get butterknife", 237, macro_stasis(), nil, { "Smooth Movements", "The Sonata of Sneakiness", "Astral Shell", "Ghostly Shell", "Leash of Linguini", "Empathy", "Butt-Rock Hair", "A Few Extra Pounds" }, "Rogue Program", 15)
		else
			inform "do ritual"
			post_page("/friars.php", { pwd = pwd, action = "ritual" })
			post_page("/friars.php", { pwd = pwd, action = "buffs", bro = "1" })
			local pandapt = get_page("/pandamonium.php")
			refresh_quest()
			if not quest("Trial By Friar") and quest_text("this is Azazel in Hell") then
				did_action = true
			end
		end
		return result, resulturl, did_action
	end

	function f.get_library_key()
		local townright = get_page("/town_right.php")
		if townright:match("The Haunted Pantry") then
			go("unlock manor", 113, macro_stasis(), {
				["Oh No, Hobo"] = "Give him a beating",
				["Trespasser"] = "Tackle him",
				["The Singing Tree"] = "&quot;No singing, thanks.&quot;",
				["The Baker's Dilemma"] = "&quot;Sorry, I'm busy right now.&quot;",
			}, {}, "Mini-Hipster", 15)
			if result:match("The Manor in Which You're Accustomed") then
				did_action = true
			end
		else
			local manor = get_page("/manor.php")
			if manor:match("Stairs Up") then
				get_page("/manor.php", { place = "stairs" })
				did_action = true
			else
				if have("pool cue") and have("handful of hand chalk") and not buff("Chalky Hand") then
					use_item("handful of hand chalk")
				end
-- 					TODO: act differently if you can't easily win with just autoattack?
				go("unlock library", 105, macro_stasis(), {
					["Minnesota Incorporeals"] = "Let the ghost break",
					["Broken"] = "Go for a solid",
					["A Hustle Here, a Hustle There"] = "Go for the 8-ball",
				}, {"Smooth Movements", "The Sonata of Sneakiness"}, "Stocking Mimic", 5)
			end
		end
		return result, resulturl, did_action
	end

	function f.get_dod_wand()
		-- TODO: don't get teleportitis that overlaps with SR
		-- do meatcar/beach/shore
		local dungeons = get_page("/dungeons.php")
		if dungeons:match("The Enormous Greater%-Than Sign") then
			if advs() < 20 then
				error("less than 20 advs for > sign")
			elseif meat() < 1000 then
				error("need 1k meat for > sign")
			elseif have("plus sign") and buff("Teleportitis") then
				fam "Frumious Bandersnatch"
				ensure_buffs { "Ode to Booze" }
				inform "TODO: find oracle, then do DD to wear off teleportitis, shore once"
			else
				go("unlock dod", 226, macro_noodlecannon(), {}, { "Smooth Movements", "The Sonata of Sneakiness", "Fat Leon's Phat Loot Lyric", "Spirit of Garlic" }, "Slimeling", 25, { choice_function = function (advtitle, choicenum)
					if advtitle == "Typographical Clutter" then
						if not have("plus sign") then
							return "The big apostrophe"
						else
							return "The upper-case Q"
						end
					end
				end })
			end
		else
			if have("dead mimic") then
				use_item("dead mimic")
				if have("pine wand") or have("ebony wand") or have("hexagonal wand") or have("aluminum wand") or have("marble wand") then
					did_action = true
				end
			elseif meat() < 5000 then
				error("need 5k meat for DoD wand")
			else
				go("get dod wand", 39, macro_noodlecannon(), {
					["Ouch!  You bump into a door!"] = "Buy what appears to be some sort of cloak (5,000 Meat)",
				}, { "Smooth Movements", "The Sonata of Sneakiness", "Fat Leon's Phat Loot Lyric", "Spirit of Garlic", "Leash of Linguini", "Empathy" }, "Slimeling", 20, {
					finalcheck = function()
						if meat() < 5000 then
							error("need 5k meat for DoD wand")
						end
					end
				})
			end
		end
		return result, resulturl, did_action
	end

	-- TODO: merge with unlock_hits
	function f.do_castle()
		-- TODO: buff +item% more?
		go("do castle in the sky", 82, macro_noodleserpent(), {}, { "Smooth Movements", "The Sonata of Sneakiness", "Fat Leon's Phat Loot Lyric", "Spirit of Garlic", "Butt-Rock Hair" }, "Slimeling", 40, { choice_function = function (advtitle, choicenum)
			if advtitle == "Wheel in the Clouds in the Sky, Keep On Turning" then
				if choicenum == 9 and get_mainstat() ~= "Mysticality" then
					return "Turn the wheel counterclockwise"
				elseif choicenum == 12 then
					return "Turn the wheel counterclockwise"
				elseif choicenum == 11 then
					return "Leave the wheel alone"
				elseif choicenum == 9 and get_mainstat() == "Mysticality" then
					return "Turn the wheel clockwise"
				elseif choicenum == 10 then
					return "Turn the wheel clockwise"
				end
			end
		end})
	end

	function f.unlock_hits()
		result, resulturl = use_item("giant castle map")
		if have("quantum egg") then
			inform "make rowboat"
			meatpaste_items("S.O.C.K.", "quantum egg")
			if have("intragalactic rowboat") then
				did_action = true
			end
		elseif result:contains("have to figure out some way to get the guard away from the door") then
			go("unlock hits", 82, macro_noodleserpent(), {}, { "Smooth Movements", "The Sonata of Sneakiness", "Fat Leon's Phat Loot Lyric", "Spirit of Garlic", "Butt-Rock Hair" }, "Slimeling", 40, { choice_function = function (advtitle, choicenum)
				if advtitle == "Wheel in the Clouds in the Sky, Keep On Turning" then
					if choicenum == 9 and get_mainstat() ~= "Mysticality" then
						return "Turn the wheel counterclockwise"
					elseif choicenum == 12 then
						return "Turn the wheel counterclockwise"
					elseif choicenum == 11 then
					elseif choicenum == 9 and get_mainstat() == "Mysticality" then
						return "Turn the wheel clockwise"
					elseif choicenum == 10 then
						return "Turn the wheel clockwise"
					end
				end
			end})
		end
	end

	function f.find_black_market()
		use_dancecard()
		if have("black market map") and have("sunken eyes") and have("broken wings") then
			inform "locate black market"
			meatpaste_items("broken wings", "sunken eyes")
			get_page("/inv_familiar.php", { whichitem = get_itemid("reassembled blackbird"), ajax = 1, pwd = pwd })
			fam "Reassembled Blackbird"
			result, resulturl = use_item("black market map")
			if not have("black market map") then
				did_action = true
			end
		else
			go("do black forest", 111, macro_noodleserpent(), nil, { "Fat Leon's Phat Loot Lyric", "Spirit of Bacon Grease" }, "Slimeling", 45)
		end
	end

	function f.get_macguffin_diary()
		inform "shore for macguffin diary"
		if not have("forged identification documents") then
			if challenge == "fist" then
				error "Get identification documents"
			else
				result, resulturl = buy_item("forged identification documents", "l")
				if not have("forged identification documents") then
					error "Failed to buy identification documents"
				end
			end
		end
		if not have("your father's MacGuffin diary") then
			result, resulturl = post_page("/shore.php", { pwd = pwd, whichtrip = "3" })
		end
		if have("your father's MacGuffin diary") then
			result, resulturl = get_page("/diary.php", { whichpage = "1" })
			did_action = true
		end
	end

	function f.do_oasis_and_desert()
		if have("worm-riding hooks") and have("drum machine") then
			inform "use drum machine"
			if challenge ~= "fist" then
				wear { weapon = "worm-riding hooks" } -- TODO: is this necessary at all anymore?
				if equipment().weapon ~= get_itemid("worm-riding hooks") then
					error "Not wearing hooks!"
				end
			end
			use_item("drum machine")
			if not have("worm-riding hooks") then
				did_action = true
			end
		elseif quest_text("got your walking shoes on") then
			go("unlock oasis", 121, macro_noodleserpent(), {
				["Let's Make a Deal!"] = "Haggle for a better price",
			}, { "Spirit of Bacon Grease" }, "Mini-Hipster", 45)
			if result:match("find yourself near an oasis") then
				use_hottub()
				did_action = true
			end
		elseif not buff("Ultrahydrated") then
			inform "getting ultrahydrated"
			if not have("ten-leaf clover") then
				use_item("disassembled clover")
			end
			if have("ten-leaf clover") or challenge == "fist" then
				result, resulturl, advagain = autoadventure(122)
				if buff("Ultrahydrated") or result:contains("You acquire an item") then
					did_action = advagain
				end
			else
				error "No clover for ultrahydrated"
			end
		elseif quest_text("managed to stumble upon a hidden oasis") then
			go("find gnasir", 123, macro_noodleserpent(), nil, { "Spirit of Bacon Grease" }, "Mini-Hipster", 45)
		elseif quest_text("tasked you with finding a stone rose") then
			if not (have("stone rose") and have("drum machine")) then
				go("get stone rose + drum machine", 122, macro_noodleserpent(), nil, { "Fat Leon's Phat Loot Lyric", "Spirit of Bacon Grease" }, "Slimeling", 45)
			elseif not have("can of black paint") then
				inform "buy paint"
				buy_item("can of black paint", "l")
				if have("can of black paint") then
					did_action = true
				end
			else
				go("return stone rose", 123, macro_noodleserpent(), nil, { "Spirit of Bacon Grease" }, "Mini-Hipster", 45)
			end
		elseif quest_text("that's probably long enough") then
			go("return to gnasir after waiting", 123, macro_noodleserpent(), nil, { "Spirit of Bacon Grease" }, "Mini-Hipster", 45)
		elseif quest_text("find fifteen missing pages") or quest_text("fourteen to go") or quest_text("thirteen to go") then
			go("find missing pages", 122, macro_noodleserpent(), nil, { "Spirit of Bacon Grease" }, "Mini-Hipster", 45)
		elseif quest_text("Time to take them back") then
			go("return pages to gnasir", 123, macro_noodleserpent(), nil, { "Spirit of Bacon Grease" }, "Mini-Hipster", 45)
		end
	end

	function f.do_never_odd_or_even_quest()
		if not have("Talisman o' Nam") then
			if not have("pirate fledges") then
				if have("ball polish") then
					use_item("ball polish")
				end
				if have("mizzenmast mop") then
					use_item("mizzenmast mop")
				end
				if have("rigging shampoo") then
					use_item("rigging shampoo")
				end
				go("doing fcle", 158, macro_noodleserpent(), {
					["Chatterboxing"] = "Fight chatty fire with chatty fire",
				}, { "Musk of the Moose", "Carlweather's Cantata of Confrontation", "Fat Leon's Phat Loot Lyric", "Spirit of Bacon Grease", "Heavy Petting", "Peeled Eyeballs", "Leash of Linguini", "Empathy" }, "Jumpsuited Hound Dog", 30, { equipment = { hat = "eyepatch", pants = "swashbuckling pants", acc1 = "stuffed shoulder parrot" } })
				if result:match("You quickly scribble a random phone number onto the napkin and hand it to the clingy pirate.") then
					advagain = true
				end
			else
-- 				use_dancecard()
				local covept = get_page("/cove.php")
				if not covept:match("Belowdecks") then
--~ quests check: choice	O Cap'm, My Cap'm	nil	nil
--~ choice	O Cap'm, My Cap'm	189
--~ opt	1	Front the meat and take the wheel
--~ opt	2	Step away from the helm
--~ got uri: /choice.php |  (from /automate-ascension-hcnp-day4), size 7097
--~ noncombat: {O Cap'm, My Cap'm} (189)
--~ posting page /choice.php params: Just [("pwd","78c111d81e1e56105e9a2c33124f31f9"),("whichchoice","189"),("option","1")]
--~ got uri: /ocean.php | ?intro=1 (from /choice.php), size 2100
--~ posting page /ocean.php params: Just [("lon","22"),("lat","62")]
--~ got uri: /ocean.php |  (from /ocean.php), size 2741
					-- TODO: noncombat choices
					go("do poop deck", 159, macro_noodlecannon(), {}, { "Butt-Rock Hair", "Smooth Movements", "The Sonata of Sneakiness", "Spirit of Bacon Grease" }, "Rogue Program", 35, {
						equipment = { acc1 = "pirate fledges" },
						finalcheck = function()
							if meat() < 977 then
								error "Not enough meat to set sail"
							end
						end,
					})
					if result:match("It's Always Swordfish") then
						did_action = true
					end
				elseif count("snakehead charrrm") >= 2 then
					inform "paste talisman"
					meatpaste_items("snakehead charrrm", "snakehead charrrm")
					if have("Talisman o' Nam") then
						did_action = true
					end
				elseif have("gaudy key") then
					inform "use gaudy key"
					local charms = count("snakehead charrrm")
					use_item("gaudy key")
					if count("snakehead charrrm") > charms then
						did_action = true
					end
				else
					go("get gaudy keys", 160, make_cannonsniff_macro("gaudy pirate"), nil, { "Spirit of Bacon Grease" }, "Rogue Program", 40, { equipment = { acc1 = "pirate fledges" }, olfact = "gaudy pirate" })
				end
			end
		else
			if have("Mega Gem") then
				go("fight dr awkward", 119, macro_noodleserpent(), {
					["Dr. Awkward"] = "War, sir, is raw!",
				}, { "A Few Extra Pounds", "Spirit of Garlic" }, "Knob Goblin Organ Grinder", 60, { equipment = { acc1 = "Mega Gem", acc2 = "Talisman o' Nam" } })
				if did_action then
					wear {}
				end
			elseif quest_text("wants some wet stew in return") then
				if have("wet stunt nut stew") then
					inform "get mega gem"
					result, resulturl, advagain = autoadventure(50)
					did_action = advagain
				elseif have("wet stew") then
					inform "cook wet stunt nut stew"
					result, resulturl = cook_items("wet stew", "stunt nuts")
					if have("wet stunt nut stew") then
						did_action = true
					end
				elseif have("bird rib") and have("lion oil") then
					inform "cook wet stew"
					result, resulturl = cook_items("bird rib", "lion oil")
					if have("wet stew") then
						did_action = true
					end
				else
					if not have("sugar shield") then
						get_page("/sugarsheets.php", { pwd = pwd, action = "fold", whichitem = get_itemid("sugar shield") })
					end
					go("get wet stew ingredients", 100, macro_autoattack(), {
						["The Only Thing About Him is the Way That He Walks"] = "Show him some moves",
						["Rapido!"] = "Steer for the cave",
						["Don't Fence Me In"] = "Jump the fence",
					}, { "Musk of the Moose", "Carlweather's Cantata of Confrontation", "Fat Leon's Phat Loot Lyric", "Heavy Petting", "Peeled Eyeballs", "Brother Flying Burrito's Blessing", "Leash of Linguini", "Empathy" }, "Jumpsuited Hound Dog", 20, { equipment = { familiarequip = "sugar shield" } })
					if result:match("It's A Sign!") then
						did_action = true
					end
					if did_action then
						wear {}
					end
				end
			elseif quest_text("track down this Mr. Alarm guy") and have("stunt nuts") then
				go("track down mr. alarm", 50, macro_stasis(), {
					["Mr. Alarm, I Presarm"] = "Talk to him",
				}, { "Smooth Movements", "The Sonata of Sneakiness" }, "Mini-Hipster", 15)
			else
				-- HACK: doesn't appear until plains is loaded
				if not have_equipped("Talisman o' Nam") then
					print("must equip talisman")
					wear { acc1 = "Talisman o' Nam" }
					get_page("/plains.php")
				end
-- 				use_dancecard()
				if meat() < 500 and not (have("photograph of God") and have("hard rock candy")) and not have("&quot;I Love Me, Vol. I&quot;") then
					error "Not enough meat for palindome"
				end
				go("do palindome", 119, macro_noodleserpent(), {
					["No sir, away!  A papaya war is on!"] = "Give the men a pep talk",
					["Sun at Noon, Tan Us"] = "A little while",
					["Rod Nevada, Vendor"] = "Accept (500 Meat)",
					["Do Geese See God?"] = "Buy the photograph (500 meat)",
					["A Pre-War Dresser Drawer, Pa!"] = "Ignawer the drawer",
				}, { "Smooth Movements", "The Sonata of Sneakiness", "Fat Leon's Phat Loot Lyric", "Spirit of Bacon Grease" }, "Slimeling", 40, { equipment = { acc1 = "Talisman o' Nam" } })
				if result:contains("Drawn Onward") and resulturl:contains("palinshelves") then
					post_page("/palinshelves.php", { action = "placeitems", whichitem1 = get_itemid("photograph of God"), whichitem2 = get_itemid("hard rock candy"), whichitem3 = get_itemid("ketchup hound"), whichitem4 = get_itemid("hard-boiled ostrich egg") })
					if have("&quot;I Love Me, Vol. I&quot;") then
						use_hottub()
						did_action = true
					end
				end
			end
		end
	end

	function f.do_orc_chasm()
		if have("64735 scroll") then
			inform "using scroll"
			use_item("64735 scroll")
			if have("facsimile dictionary") then
				did_action = true
			end
		elseif quest_text("You must find your way past the Orc Chasm") then
			inform "unlock baron's valley"
			result, resulturl = post_page("/forestvillage.php", { pwd = pwd, action = "untinker", whichitem = get_itemid("abridged dictionary") })
			result, resulturl = get_page("/mountains.php", { pwd = pwd, orcs = 1 })
			refresh_quest()
			if not quest_text("You must find your way past the Orc Chasm") then
				did_action = true
			end
		elseif have("Wand of Nagamar") then
			if f.get_photocopied_monster() ~= "rampaging adding machine" then
				inform "get adding machine from faxbot"
				f.get_faxbot_fax("rampaging adding machine", "adding_machine")
			else
				inform "fight adding machine"
				f.heal_up()
				f.ensure_mp(30)
				wear {}
				fam "Llama Lama"
				local pt, url = use_item("photocopied monster")
				pt, url = get_page("/fight.php")
				result, resulturl, advagain = handle_adventure_result(pt, url, "?", macro_orc_chasm())
				if advagain and have("64735 scroll") then
					did_action = true
				end
			end
		elseif have("lowercase N") then
			if not have("ruby W") then error "Missing ruby W" end
			if not have("metallic A") then error "Missing metallic A" end
			if not have("lowercase N") then error "Missing lowercase N" end
			if not have("heavy D") then error "Missing heavy D" end
			inform "meatpasting wand"
			meatpaste_items("ruby W", "metallic A")
			meatpaste_items("lowercase N", "heavy D")
			meatpaste_items("WA", "ND")
			if have("Wand of Nagamar") then
				did_action = true
			end
		elseif count("334 scroll") >= 2 and have("30669 scroll") and have("33398 scroll") then
			go("doing orc chasm", 80, macro_orc_chasm(), {}, { "Spirit of Bacon Grease", "Heavy Petting", "Leash of Linguini", "Empathy", "Ur-Kel's Aria of Annoyance" }, "Jumpsuited Hound Dog", 50, { equipment = { familiarequip = "sugar shield" }, olfact = "XXX pr0n" })
		else
			error "Error while doing orc chasm"
		end
	end

	function f.get_faxbot_fax(target, code)
		if playername():contains("Devster") then
			error("Devster faxbot:" .. target)
		end
		print("photocopied:", f.get_photocopied_monster(), "getting", target, code)
		-- TODO: make this possible from fax page, not just automation
		local function timestamp()
			local t = os.date("*t")
			return t.hour * 3600 + t.min * 60 + t.sec
		end
		if f.get_photocopied_monster() == nil then
			get_page("/submitnewchat.php", { pwd = pwd, graf = ("/msg FaxBot "..code) })
			local tstart = timestamp()
			for i = 1, 100 do
				local pt = get_page("/clan_log.php")
				local faxedtext = pt:match("faxed in .-<")
				if not faxedtext then
					error "Error when checking clan log for faxbot"
				end
				if faxedtext:contains(target) then
					break
				end
				if timestamp() > tstart + 300 then
					break
				end
			end
-- 			/clan_viplounge.php [("preaction","sendfax")]
-- 			/clan_viplounge.php [("preaction","receivefax")]
			get_page("/clan_viplounge.php", { preaction = "receivefax" })
		end
		if f.get_photocopied_monster() == target then
			did_action = true
		else
			error("Failed to get "..target.." from faxbot")
		end
	end

	-- TODO: 1 more with bander if possible
	function f.spooky_forest_runaways()
		local woodspt = get_page("/woods.php")
		if woodspt:contains("The Hidden Temple") then return end
		fam "Pair of Stomping Boots"
		ensure_buffs { "Leash of Linguini", "Empathy" }
		local weareq = {}
		wear(weareq)
		if buffedfamiliarweight() < (1 + get_daily_counter("familiar.free butt runaways")) * 5 then
			weareq = { familiarequip = "sugar shield" }
			wear(weareq)
			ensure_buffs { "Heavy Petting" }
		end
-- 		print("weareq:", table_to_str(weareq))
		if buffedfamiliarweight() >= (1 + get_daily_counter("familiar.free butt runaways")) * 5 then
			-- TODO: copy-pasted, merge this
			if have("Spooky Temple map") and have("Spooky-Gro fertilizer") and have("spooky sapling") then
				inform "use spooky temple map"
				use_item("Spooky Temple map")
				local newwoodspt = get_page("/woods.php")
				if newwoodspt:contains("The Hidden Temple") then
					did_action = true
				end
			else
				if meat() < 100 and have("Spooky Temple map") and have("Spooky-Gro fertilizer") then
					error "Not enough meat for spooky sapling"
				end
				go("runaways to unlock hidden temple, " .. buffedfamiliarweight() .. " lb, already done " .. get_daily_counter("familiar.free butt runaways") .. " runaways", 15, macro_spooky_forest_runaway(), {}, { "Smooth Movements", "The Sonata of Sneakiness" }, "Pair of Stomping Boots", 10, { choice_function = function (advtitle, choicenum)
					if advtitle == "Arboreal Respite" then
						if not have("Spooky Temple map") then
							if not have("tree-holed coin") then
								return "Explore the stream"
							else
								return "Brave the dark thicket"
							end
						elseif not have("Spooky-Gro fertilizer") then
							return "Brave the dark thicket"
						elseif not have("spooky sapling") then
							return "Follow the old road"
						end
					elseif advtitle == "Consciousness of a Stream" then
						if not have("Spooky Temple map") and not have("tree-holed coin") then
							inform "get coin"
							return "Squeeze into the cave"
						end
					elseif advtitle == "Through Thicket and Thinnet" then
						if not have("Spooky Temple map") then
							return "Follow the coin"
						elseif not have("Spooky-Gro fertilizer") then
							inform "get fertilizer"
							return "Investigate the dense foliage"
						end
					elseif advtitle == "O Lith, Mon" then
						inform "get map"
						return "Insert coin to continue"
					elseif advtitle == "The Road Less Traveled" then
						if not have("spooky sapling") then
							return "Talk to the hunter"
						end
					elseif advtitle == "Tree's Last Stand" then
						if not have("spooky sapling") then
							inform "buying sapling"
							return "Buy a tree for 100 Meat"
						else
							return "Take your leave"
						end
					end
				end, equipment = weareq, finalcheck = function()
-- 					print("final bander weight check:", buffedfamiliarweight())
-- 					print("  wearing", table_to_str(equipment()))
					if buffedfamiliarweight() < (1 + get_daily_counter("familiar.free butt runaways")) * 5 then
						error "Fam weight somehow got too low!"
					end
				end })
	-- BUG: reads adventure title as Results. -> workaround.
	-- noncombat: {Results:} (504)
	-- fallback for	Results:	504
				if not did_action and have("spooky sapling") and result:contains("Results:") then
					result, resulturl = post_page("/choice.php", { pwd = pwd, whichchoice = 504, option = 4 })
					result, resulturl, advagain = handle_adventure_result(result, resulturl, 15, nil, {})
					did_action = advagain
				end
-- 				print(resulturl, resulturl:contains("fight.php"), result:contains("tosses you onto his back, and flooms away"))
				if resulturl:contains("fight.php") and not (result:contains("tosses you onto his back, and flooms away") or result:contains("kicks you in the butt to speed your escape.")) then
					print("failed to run away, wtf?", resulturl, ", page text:")
					print("   +++   ")
					print(result)
					print("   ---   ")
					error "Failed to use free butt-runaway"
				end
			end
			wear {}
			return result, resulturl, did_action
		end
	end
	return f
end
